; ##############################################################################
; ##############################################################################
; ##############################################################################
;     Berechnung der Kapazitt
;    Cp=(f2^2 x Cref) / (f1^2 - f2^2)
;
BERECHNUNG_C:
    ; HILFSREGISTER sichern
    push R1
    push R2
    push R3
    push R4
    push R5
    push R6
    push R7
    push R8

    ; Frequenz f1 quadrieren
    LDS temp1,(adr_FREQUENZ_F1_BYTE_1)
    LDS temp2,(adr_FREQUENZ_F1_BYTE_2)
    LDS temp3,(adr_FREQUENZ_F1_BYTE_3)
    clr temp4
    LDS temp5,(adr_FREQUENZ_F1_BYTE_1)
    LDS temp6,(adr_FREQUENZ_F1_BYTE_2)
    LDS temp7,(adr_FREQUENZ_F1_BYTE_3)
    clr temp8
    rcall FUNKTION_MULTIPLIKATION_32_32    ; INP: TEMP1...4 / TEMP5...8 OUT: TEMP1...8
    ; speichern
    STS (adr_FREQUENZ_Q_F1_BYTE_1),temp1
    STS (adr_FREQUENZ_Q_F1_BYTE_2),temp2
    STS (adr_FREQUENZ_Q_F1_BYTE_3),temp3
    STS (adr_FREQUENZ_Q_F1_BYTE_4),temp4
    STS (adr_FREQUENZ_Q_F1_BYTE_5),temp5
    STS (adr_FREQUENZ_Q_F1_BYTE_6),temp6
    ; Kalibrierungsfrequenz laden und als f2 speichern
    LDS temp1,(adr_FREQUENZ_KALI_BYTE_1)
    LDS temp2,(adr_FREQUENZ_KALI_BYTE_2)
    LDS temp3,(adr_FREQUENZ_KALI_BYTE_3)
    STS (adr_FREQUENZ_F2_BYTE_1),temp1
    STS (adr_FREQUENZ_F2_BYTE_2),temp2
    STS (adr_FREQUENZ_F2_BYTE_3),temp3
    ; Frequenz f2 quadrieren
    LDS temp1,(adr_FREQUENZ_F2_BYTE_1)
    LDS temp2,(adr_FREQUENZ_F2_BYTE_2)
    LDS temp3,(adr_FREQUENZ_F2_BYTE_3)
    clr temp4
    LDS temp5,(adr_FREQUENZ_F2_BYTE_1)
    LDS temp6,(adr_FREQUENZ_F2_BYTE_2)
    LDS temp7,(adr_FREQUENZ_F2_BYTE_3)
    clr temp8
    rcall FUNKTION_MULTIPLIKATION_32_32    ; INP: TEMP1...4 / TEMP5...8 OUT: TEMP1...8
    ; speichern
    STS (adr_FREQUENZ_Q_F2_BYTE_1),temp1
    STS (adr_FREQUENZ_Q_F2_BYTE_2),temp2
    STS (adr_FREQUENZ_Q_F2_BYTE_3),temp3
    STS (adr_FREQUENZ_Q_F2_BYTE_4),temp4
    STS (adr_FREQUENZ_Q_F2_BYTE_5),temp5
    STS (adr_FREQUENZ_Q_F2_BYTE_6),temp6

;-------------------------------------------
    ; 1. SCHRITT => f2^2 mal Cref => Ergebnis 1

    ; f2^2 laden
    LDS temp1,(adr_FREQUENZ_Q_F2_BYTE_1)
    LDS temp2,(adr_FREQUENZ_Q_F2_BYTE_2)
    LDS temp3,(adr_FREQUENZ_Q_F2_BYTE_3)
    LDS temp4,(adr_FREQUENZ_Q_F2_BYTE_4)
    LDS temp5,(adr_FREQUENZ_Q_F2_BYTE_5)
    LDS temp6,(adr_FREQUENZ_Q_F2_BYTE_6)
    clr temp7
    clr temp8

    ; Hilfsregister initialisiern
    mov R1,temp1
    mov R2,temp2
    mov R3,temp3
    mov R4,temp4
    mov R5,temp5
    mov R6,temp6
    mov R7,temp7
    mov R8,temp8
    ; Cref laden
    LDS ZL,(adr_REFERENZ_C_BYTE_1)
    LDS ZH,(adr_REFERENZ_C_BYTE_2)
    ; Schleife initialisiern (Z-1)
    sbiw ZL,1

    ; SCHLEIFE
BERECHNUNG_C_SCHLEIFE:
    ; Multiplikation durch addition
    add temp1,R1
    adc temp2,R2
    adc temp3,R3
    adc temp4,R4
    adc temp5,R5
    adc temp6,R6
    adc temp7,R7
    adc temp8,R8
    ; Schleifenzhler minus 1
    sbiw ZL,1
    tst ZL
    brne BERECHNUNG_C_SCHLEIFE
    tst ZH
    brne BERECHNUNG_C_SCHLEIFE
    ; Ergebnis speichern
    STS (adr_ERGEBNIS_1_BYTE_1),temp1
    STS (adr_ERGEBNIS_1_BYTE_2),temp2
    STS (adr_ERGEBNIS_1_BYTE_3),temp3
    STS (adr_ERGEBNIS_1_BYTE_4),temp4
    STS (adr_ERGEBNIS_1_BYTE_5),temp5
    STS (adr_ERGEBNIS_1_BYTE_6),temp6
    STS (adr_ERGEBNIS_1_BYTE_7),temp7
    STS (adr_ERGEBNIS_1_BYTE_8),temp8


;-------------------------------------------
    ; 2. SCHRITT => f1^2 minus f2^2     => Ergebnis 2
    ; f1^2 laden
    LDS temp1,(adr_FREQUENZ_Q_F1_BYTE_1)
    LDS temp2,(adr_FREQUENZ_Q_F1_BYTE_2)
    LDS temp3,(adr_FREQUENZ_Q_F1_BYTE_3)
    LDS temp4,(adr_FREQUENZ_Q_F1_BYTE_4)
    LDS temp5,(adr_FREQUENZ_Q_F1_BYTE_5)
    LDS temp6,(adr_FREQUENZ_Q_F1_BYTE_6)
    clr temp7
    clr temp8
    ; f2^2 laden
    LDS    R1,(adr_FREQUENZ_Q_F2_BYTE_1)
    LDS    R2,(adr_FREQUENZ_Q_F2_BYTE_2)
    LDS    R3,(adr_FREQUENZ_Q_F2_BYTE_3)
    LDS    R4,(adr_FREQUENZ_Q_F2_BYTE_4)
    LDS    R5,(adr_FREQUENZ_Q_F2_BYTE_5)
    LDS    R6,(adr_FREQUENZ_Q_F2_BYTE_6)
    clr    R7
    clr    R8
    ; SUBTRAKTION
    sub temp1,R1
    sbc temp2,R2
    sbc temp3,R3
    sbc temp4,R4
    sbc temp5,R5
    sbc temp6,R6
    sbc temp7,R7
    sbc temp8,R8
    ; Ergebnis speichern
    STS (adr_ERGEBNIS_2_BYTE_1),temp1
    STS (adr_ERGEBNIS_2_BYTE_2),temp2
    STS (adr_ERGEBNIS_2_BYTE_3),temp3
    STS (adr_ERGEBNIS_2_BYTE_4),temp4
    STS (adr_ERGEBNIS_2_BYTE_5),temp5
    STS (adr_ERGEBNIS_2_BYTE_6),temp6
    STS (adr_ERGEBNIS_2_BYTE_7),temp7
    STS (adr_ERGEBNIS_2_BYTE_8),temp8
;-------------------------------------------
    ; 3. SCHRITT => Vorbereiten auf Division (64 BIT Zahl auf 32 Bit krzen)

    ; Umwandlung auf 32 Bit_Zahl
BERECHNUNG_C_B8:
    LDS temp,(adr_ERGEBNIS_1_BYTE_8)    ; Byte 8 laden
    tst temp                            ; = NULL ?
    breq BERECHNUNG_C_B7                ; ja => SPRUNG
    rcall ZWISCHENERGEBNISSE_HALBIEREN    ; Ergebnisse halbieren
    rjmp BERECHNUNG_C_B8                ; erneute Prfung

BERECHNUNG_C_B7:
    LDS temp,(adr_ERGEBNIS_1_BYTE_7)    ; Byte 7 laden
    tst temp                            ; = NULL ?
    breq BERECHNUNG_C_B6                ; ja => SPRUNG
    rcall ZWISCHENERGEBNISSE_HALBIEREN    ; Ergebnisse halbieren
    rjmp BERECHNUNG_C_B7                ; erneute Prfung

BERECHNUNG_C_B6:
    LDS temp,(adr_ERGEBNIS_1_BYTE_6)    ; Byte 6 laden
    tst temp                            ; = NULL ?
    breq BERECHNUNG_C_B5                ; ja => SPRUNG
    rcall ZWISCHENERGEBNISSE_HALBIEREN    ; Ergebnisse halbieren
    rjmp BERECHNUNG_C_B6                ; erneute Prfung
BERECHNUNG_C_B5:
    LDS temp,(adr_ERGEBNIS_1_BYTE_5)    ; Byte 5 laden
    tst temp                            ; = NULL ?
    breq BERECHNUNG_C_B_FERTIG            ; ja => SPRUNG
    rcall ZWISCHENERGEBNISSE_HALBIEREN    ; Ergebnisse halbieren
    rjmp BERECHNUNG_C_B5                ; erneute Prfung
BERECHNUNG_C_B_FERTIG:
;-------------------------------------------
    ; 4. SCHRITT => DIVISION => ERGEBNIS 1  durch Ergebnis 2
    ; Ergebnis 1 laden
    LDS temp1,(adr_ERGEBNIS_1_BYTE_1)
    LDS temp2,(adr_ERGEBNIS_1_BYTE_2)
    LDS temp3,(adr_ERGEBNIS_1_BYTE_3)
    LDS temp4,(adr_ERGEBNIS_1_BYTE_4)
    ; Ergebnis 2 laden
    LDS temp5,(adr_ERGEBNIS_2_BYTE_1)
    LDS temp6,(adr_ERGEBNIS_2_BYTE_2)
    LDS temp7,(adr_ERGEBNIS_2_BYTE_3)
    LDS temp8,(adr_ERGEBNIS_2_BYTE_4)
    ; DIVISION
    rcall DIVISION_32_32    ; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4
    ; SPEICHERN
    STS (adr_KAPAZITAET_BYTE_1),temp1
    STS (adr_KAPAZITAET_BYTE_2),temp2
    STS (adr_KAPAZITAET_BYTE_3),temp3
    ; HILFSREGISTER wieder herstellen
    pop temp8
    pop temp7
    pop temp6
    pop temp5
    pop temp4
    pop temp3
    pop temp2
    pop temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; BERECHNUNG INDUKTIVITT
; Lp= 1 / (4 x PI^2 * f1^2 * C)
BERECHNUNG_L:
    ; HILFSREGISTER sichern
    push R1
    push R2
    push R3
    push R4
    push R5
    push R6
    push R7
    push R8
;--------------------------------------------------------------------------------
    ; 1. Schritt:  f1^2 mal 4*pi^2
    ; Frequenz f1 Quadrat laden
    LDS temp1,(adr_FREQUENZ_Q_F1_BYTE_1)
    LDS temp2,(adr_FREQUENZ_Q_F1_BYTE_2)
    LDS temp3,(adr_FREQUENZ_Q_F1_BYTE_3)
    LDS temp4,(adr_FREQUENZ_Q_F1_BYTE_4)
    LDS temp5,(adr_FREQUENZ_Q_F1_BYTE_5)
    LDS temp6,(adr_FREQUENZ_Q_F1_BYTE_6)
    clr temp7
    clr temp8
    ; Hilfsregister    initialisieren
    mov R1,temp1
    mov R2,temp2
    mov R3,temp3
    mov R4,temp4
    mov R5,temp5
    mov R6,temp6
    mov R7,temp7
    mov R8,temp8
    ; Schleife Z-initialisieren
    ; Z= 4*pi^2 (39,4784176 = 3948)
    ldi ZL,BYTE1(3948)
    ldi ZH,BYTE2(3948)
    sbiw ZL,1
    ; SCHLEIFE
BERECHNUNG_L_SCHLEIFE:
    ; Multiplikation durch addition
    add temp1,R1
    adc temp2,R2
    adc temp3,R3
    adc temp4,R4
    adc temp5,R5
    adc temp6,R6
    adc temp7,R7
    adc temp8,R8
    ; Schleifenzhler minus 1
    sbiw ZL,1
    tst ZL
    brne BERECHNUNG_L_SCHLEIFE
    tst ZH
    brne BERECHNUNG_L_SCHLEIFE
;---------------------------------------------------
    ; 2. Schritt mal Kapazitt
    ; Hilfsregister    initialisieren
    mov R1,temp1
    mov R2,temp2
    mov R3,temp3
    mov R4,temp4
    mov R5,temp5
    mov R6,temp6
    mov R7,temp7
    mov R8,temp8

    ; Kapazitt laden (Bsp: 4525)
    LDS XL,(adr_KAPAZITAET_BYTE_1)
    LDS ZL,(adr_KAPAZITAET_BYTE_2)
    LDS ZH,(adr_KAPAZITAET_BYTE_3)
    sub    XL,EINS
    sbc ZL,NULL
    sbc ZH,NULL

BERECHNUNG_L_SCHLEIFE_2:
    ; Multiplikation durch addition
    add temp1,R1
    adc temp2,R2
    adc temp3,R3
    adc temp4,R4
    adc temp5,R5
    adc temp6,R6
    adc temp7,R7
    adc temp8,R8
    ; Schleifenzhler minus 1
    sub    XL,EINS
    sbc ZL,NULL
    sbc ZH,NULL
    tst XL
    brne BERECHNUNG_L_SCHLEIFE_2
    tst ZL
    brne BERECHNUNG_L_SCHLEIFE_2
    tst ZH
    brne BERECHNUNG_L_SCHLEIFE_2
    ; Ergebnis speichern (2)
    STS (adr_ERGEBNIS_2_BYTE_1),temp1
    STS (adr_ERGEBNIS_2_BYTE_2),temp2
    STS (adr_ERGEBNIS_2_BYTE_3),temp3
    STS (adr_ERGEBNIS_2_BYTE_4),temp4
    STS (adr_ERGEBNIS_2_BYTE_5),temp5
    STS (adr_ERGEBNIS_2_BYTE_6),temp6
    STS (adr_ERGEBNIS_2_BYTE_7),temp7
    STS (adr_ERGEBNIS_2_BYTE_8),temp8
    ; speichern TESTZAHLEN (dient nur zur berprfung des Programmes)
    STS (adr_TEST_A_BYTE_1),temp1
    STS (adr_TEST_A_BYTE_2),temp2
    STS (adr_TEST_A_BYTE_3),temp3
    STS (adr_TEST_A_BYTE_4),temp4
    STS (adr_TEST_A_BYTE_5),temp5
    STS (adr_TEST_A_BYTE_6),temp6
    STS (adr_TEST_A_BYTE_7),temp7
    STS (adr_TEST_A_BYTE_8),temp8
;----------------------------------------------------------------
    ; 3. Schritt vorbereiten auf Division

    ; Ergebnis(2)40 mal durch 2 teilen
    ldi temp,40
BERECHNUNG_L_HALB:
    rcall ZWISCHENERGEBNISSE_HALBIEREN
    dec temp
    brne BERECHNUNG_L_HALB


;----------------------------------------------------------------
    ; 3. Schritt Division

    ;DIVIDENT
    ;  100.000.000.000.000.000.000 40mal halbiert

    ldi temp1,BYTE1(90949470)
    ldi temp2,BYTE2(90949470)
    ldi temp3,BYTE3(90949470)
    ldi temp4,BYTE4(90949470)
    ; DIVISOR
    LDS temp5,(adr_ERGEBNIS_2_BYTE_1)
    LDS temp6,(adr_ERGEBNIS_2_BYTE_2)
    LDS temp7,(adr_ERGEBNIS_2_BYTE_3)
    LDS temp8,(adr_ERGEBNIS_2_BYTE_4)
    rcall DIVISION_32_32    ; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4



    ; INDUKTIVITT speichern
    STS (adr_INDUKTIVITAET_BYTE_1),temp1
    STS (adr_INDUKTIVITAET_BYTE_2),temp2
    STS (adr_INDUKTIVITAET_BYTE_3),temp3
    ; HILFSREGISTER wieder herstellen
    pop R8
    pop R7
    pop R6
    pop R5
    pop R4
    pop R3
    pop R2
    pop R1
ret

; ##############################################################################
; ##############################################################################
; ##############################################################################
; Berechnung Cx (CX parallel zu L und C)
; Cx = ((f1^2 / f2^2) -1) x C
; Cx = ((f1^2*1000 / f2^2) -1000) x C
BERECHNUNG_CX:

;-------------------------------------------
    ; ((f1^2*1000 / f2^2) -1000)
    rcall HILFSRECHNUNG10        ; out: temp1...4, - UP modifiziert 10-facher Wert
                                 ; fr Ausgabe mit 1 Kommastelle
;-------------------------------------------
    ; MAL Kondensator (C)
    LDS temp5,(adr_KAPAZITAET_BYTE_1)
    LDS temp6,(adr_KAPAZITAET_BYTE_2)
    LDS temp7,(adr_KAPAZITAET_BYTE_3)
    clr temp8
    rcall FUNKTION_MULTIPLIKATION_32_32    ; INP: TEMP1...4 / TEMP5...8 OUT: TEMP1...8
;-------------------------------------------
    ; durch 1000
    ldi temp5,BYTE1(1000)
    ldi temp6,BYTE2(1000)
    ldi temp7,BYTE3(1000)
    ldi temp8,BYTE4(1000)
    rcall DIVISION_32_32    ; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4
    ; SPEICHERN
    STS(adr_CX_BYTE_1),temp1
    STS(adr_CX_BYTE_2),temp2
    STS(adr_CX_BYTE_3),temp3

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BERECHNUNG_LX_SERIEL:

;-------------------------------------------
    ; ((f1^2*1000 / f2^2) -1000)
    rcall HILFSRECHNUNG100        ; out: temp1...4, - UP modifiziert 100-facher Wert
                                 ; fr Ausgabe mit 2 Kommastellen

;-------------------------------------------
    ; MAL Induktivitt (L)
    LDS temp5,(adr_INDUKTIVITAET_BYTE_1)
    LDS temp6,(adr_INDUKTIVITAET_BYTE_2)
    LDS temp7,(adr_INDUKTIVITAET_BYTE_3)
    clr temp8
    rcall FUNKTION_MULTIPLIKATION_32_32    ; INP: TEMP1...4 / TEMP5...8 OUT: TEMP1...8
;-------------------------------------------
    ; durch 1000
    ldi temp5,BYTE1(1000)
    ldi temp6,BYTE2(1000)
    ldi temp7,BYTE3(1000)
    ldi temp8,BYTE4(1000)
    rcall DIVISION_32_32    ; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4
    ; SPEICHERN
    STS(adr_LX_BYTE_1),temp1
    STS(adr_LX_BYTE_2),temp2
    STS(adr_LX_BYTE_3),temp3
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Berechnung Lx (parallel zu L und C)
; Lx = L / ((f2^2/f1^2) -1)
BERECHNUNG_LX_PARALLEL:

    ; HILFSREGISTER sichern
    push R1
    push R2
    push R3
    push R4
    push R5
    push R6
    push R7
    push R8
;------------------------------------------------------------------------------
    ; Frequenz f2 ermitteln    (mit Lx parallel)
    LDS temp1,(adr_FREQUENZ_MOMENTAN_BYTE_1)
    LDS temp2,(adr_FREQUENZ_MOMENTAN_BYTE_2)
    LDS temp3,(adr_FREQUENZ_MOMENTAN_BYTE_3)
    ; SIMULATION aktiviert ?
    LDS temp,(adr_SIMULATION_AKTIV)
    tst temp
    breq BERECHNUNG_LX_PARALLEL_NO_S
    ; TESTZAHLEN (F2_L_P)
    ldi temp1,BYTE1(F2_L_P)
    ldi temp2,BYTE2(F2_L_P)
    ldi temp3,BYTE3(F2_L_P)
BERECHNUNG_LX_PARALLEL_NO_S:
    ; speichern
    STS(adr_FREQUENZ_F2_BYTE_1),temp1
    STS(adr_FREQUENZ_F2_BYTE_2),temp2
    STS(adr_FREQUENZ_F2_BYTE_3),temp3
    ; Frequenz f2 quadrieren
    LDS temp1,(adr_FREQUENZ_F2_BYTE_1)
    LDS temp2,(adr_FREQUENZ_F2_BYTE_2)
    LDS temp3,(adr_FREQUENZ_F2_BYTE_3)
    clr temp4
    LDS temp5,(adr_FREQUENZ_F2_BYTE_1)
    LDS temp6,(adr_FREQUENZ_F2_BYTE_2)
    LDS temp7,(adr_FREQUENZ_F2_BYTE_3)
    clr temp8
    rcall FUNKTION_MULTIPLIKATION_32_32    ; INP: TEMP1...4 / TEMP5...8 OUT: TEMP1...8
;------------------------------------------------------------------------------
    ;  mal 1000
    ; Hilfsregister initialisiern
    mov R1,temp1
    mov R2,temp2
    mov R3,temp3
    mov R4,temp4
    mov R5,temp5
    mov R6,temp6
    mov R7,temp7
    mov R8,temp8
    ; Schleife initialisiern (Z-1)
    ldi ZL,LOW(1000)
    ldi ZH,HIGH (1000)
    sbiw ZL,1

    ; SCHLEIFE
BERECHNUNG_LX_PARALLEL_SCHLEIFE:
    ; Multiplikation durch addition
    add temp1,R1
    adc temp2,R2
    adc temp3,R3
    adc temp4,R4
    adc temp5,R5
    adc temp6,R6
    adc temp7,R7
    adc temp8,R8
    ; Schleifenzhler minus 1
    sbiw ZL,1
    tst ZL
    brne BERECHNUNG_LX_PARALLEL_SCHLEIFE
    tst ZH
    brne BERECHNUNG_LX_PARALLEL_SCHLEIFE
    ; ZWISCHEN-Ergebnis(1) speichern
    STS (adr_ERGEBNIS_1_BYTE_1),temp1
    STS (adr_ERGEBNIS_1_BYTE_2),temp2
    STS (adr_ERGEBNIS_1_BYTE_3),temp3
    STS (adr_ERGEBNIS_1_BYTE_4),temp4
    STS (adr_ERGEBNIS_1_BYTE_5),temp5
    STS (adr_ERGEBNIS_1_BYTE_6),temp6
    STS (adr_ERGEBNIS_1_BYTE_7),temp7
    STS (adr_ERGEBNIS_1_BYTE_8),temp8
;------------------------------------------------------------------------------
    ; f1^2 laden (quadrierte Leerlauffrequenz)
    LDS temp1,(adr_FREQUENZ_Q_F1_BYTE_1)
    LDS temp2,(adr_FREQUENZ_Q_F1_BYTE_2)
    LDS temp3,(adr_FREQUENZ_Q_F1_BYTE_3)
    LDS temp4,(adr_FREQUENZ_Q_F1_BYTE_4)
    LDS temp5,(adr_FREQUENZ_Q_F1_BYTE_5)
    LDS temp6,(adr_FREQUENZ_Q_F1_BYTE_6)
    clr temp7
    clr temp8
    ; als ZWISCHEN-Ergebnis(2) speichern
    STS (adr_ERGEBNIS_2_BYTE_1),temp1
    STS (adr_ERGEBNIS_2_BYTE_2),temp2
    STS (adr_ERGEBNIS_2_BYTE_3),temp3
    STS (adr_ERGEBNIS_2_BYTE_4),temp4
    STS (adr_ERGEBNIS_2_BYTE_5),temp5
    STS (adr_ERGEBNIS_2_BYTE_6),temp6
    STS (adr_ERGEBNIS_2_BYTE_7),temp7
    STS (adr_ERGEBNIS_2_BYTE_8),temp8
;------------------------------------------------------------------------------
    ; solange krzen, bis 32 BIT ZAHLEN entstehen ZWISCHEN-Ergebnis(1) +(2)
    ; Umwandlung auf 32 Bit_Zahl
BERECHNUNG_LX_PARALLEL_B8:
    LDS temp,(adr_ERGEBNIS_1_BYTE_8)    ; Byte 8 laden
    tst temp                            ; = NULL ?
    breq BERECHNUNG_LX_PARALLEL_B7        ; ja => SPRUNG
    rcall ZWISCHENERGEBNISSE_HALBIEREN    ; Ergebnisse halbieren
    rjmp BERECHNUNG_LX_PARALLEL_B8        ; erneute Prfung

BERECHNUNG_LX_PARALLEL_B7:
    LDS temp,(adr_ERGEBNIS_1_BYTE_7)    ; Byte 7 laden
    tst temp                            ; = NULL ?
    breq BERECHNUNG_LX_PARALLEL_B6        ; ja => SPRUNG
    rcall ZWISCHENERGEBNISSE_HALBIEREN    ; Ergebnisse halbieren
    rjmp BERECHNUNG_LX_PARALLEL_B7        ; erneute Prfung

BERECHNUNG_LX_PARALLEL_B6:
    LDS temp,(adr_ERGEBNIS_1_BYTE_6)    ; Byte 6 laden
    tst temp                            ; = NULL ?
    breq BERECHNUNG_LX_PARALLEL_B5        ; ja => SPRUNG
    rcall ZWISCHENERGEBNISSE_HALBIEREN    ; Ergebnisse halbieren
    rjmp BERECHNUNG_LX_PARALLEL_B6        ; erneute Prfung
BERECHNUNG_LX_PARALLEL_B5:
    LDS temp,(adr_ERGEBNIS_1_BYTE_5)    ; Byte 5 laden
    tst temp                            ; = NULL ?
    breq BERECHNUNG_LX_PARALLEL_B_FERTIG; ja => SPRUNG
    rcall ZWISCHENERGEBNISSE_HALBIEREN    ; Ergebnisse halbieren
    rjmp BERECHNUNG_LX_PARALLEL_B5        ; erneute Prfung
BERECHNUNG_LX_PARALLEL_B_FERTIG:
;------------------------------------------------------------------------------
    ; DIVISION => ERGEBNIS (1)  durch Ergebnis (2)
    ; Ergebnis 1 laden
    LDS temp1,(adr_ERGEBNIS_1_BYTE_1)
    LDS temp2,(adr_ERGEBNIS_1_BYTE_2)
    LDS temp3,(adr_ERGEBNIS_1_BYTE_3)
    LDS temp4,(adr_ERGEBNIS_1_BYTE_4)
    ; Ergebnis 2 laden
    LDS temp5,(adr_ERGEBNIS_2_BYTE_1)
    LDS temp6,(adr_ERGEBNIS_2_BYTE_2)
    LDS temp7,(adr_ERGEBNIS_2_BYTE_3)
    LDS temp8,(adr_ERGEBNIS_2_BYTE_4)
    ; DIVISION
    rcall DIVISION_32_32    ; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4
;------------------------------------------------------------------------------
    ; SCHRITT => MINUS 1000
    ldi temp5,BYTE1(1000)
    ldi temp6,BYTE2(1000)
    ldi temp7,BYTE3(1000)
    ldi temp8,BYTE4(1000)

    sub temp1,temp5
    sbc temp2,temp6
    sbc temp3,temp7
    sbc temp4,temp8

    clr temp5
    clr temp6
    clr temp7
    clr temp8
;------------------------------------------------------------------------------
    ; als ZWISCHEN-Ergebnis(2) speichern
    STS (adr_ERGEBNIS_2_BYTE_1),temp1
    STS (adr_ERGEBNIS_2_BYTE_2),temp2
    STS (adr_ERGEBNIS_2_BYTE_3),temp3
    STS (adr_ERGEBNIS_2_BYTE_4),temp4
    STS (adr_ERGEBNIS_2_BYTE_5),temp5
    STS (adr_ERGEBNIS_2_BYTE_6),temp6
    STS (adr_ERGEBNIS_2_BYTE_7),temp7
    STS (adr_ERGEBNIS_2_BYTE_8),temp8
;------------------------------------------------------------------------------
    ; INDUKTIVITT L laden
    LDS temp1,(adr_INDUKTIVITAET_BYTE_1)
    LDS temp2,(adr_INDUKTIVITAET_BYTE_2)
    LDS temp3,(adr_INDUKTIVITAET_BYTE_3)
    clr temp4
    ; mal 1000
    ldi temp5,BYTE1(1000)
    ldi temp6,BYTE2(1000)
    ldi temp7,BYTE3(1000)
    ldi temp8,BYTE4(1000)
    rcall FUNKTION_MULTIPLIKATION_32_32    ; INP: TEMP1...4 / TEMP5...8 OUT: TEMP1...8
    ; als ZWISCHEN-Ergebnis(1) speichern
    STS (adr_ERGEBNIS_1_BYTE_1),temp1
    STS (adr_ERGEBNIS_1_BYTE_2),temp2
    STS (adr_ERGEBNIS_1_BYTE_3),temp3
    STS (adr_ERGEBNIS_1_BYTE_4),temp4
    STS (adr_ERGEBNIS_1_BYTE_5),temp5
    STS (adr_ERGEBNIS_1_BYTE_6),temp6
    STS (adr_ERGEBNIS_1_BYTE_7),temp7
    STS (adr_ERGEBNIS_1_BYTE_8),temp8
;------------------------------------------------------------------------------
    ; Zwischenergebnis (1) durch Zwischenergebnis(2) teilen
    ; Ergebnis (1) laden
    LDS temp1,(adr_ERGEBNIS_1_BYTE_1)
    LDS temp2,(adr_ERGEBNIS_1_BYTE_2)
    LDS temp3,(adr_ERGEBNIS_1_BYTE_3)
    LDS temp4,(adr_ERGEBNIS_1_BYTE_4)
    ; Ergebnis (2) laden
    LDS temp5,(adr_ERGEBNIS_2_BYTE_1)
    LDS temp6,(adr_ERGEBNIS_2_BYTE_2)
    LDS temp7,(adr_ERGEBNIS_2_BYTE_3)
    LDS temp8,(adr_ERGEBNIS_2_BYTE_4)
    ; DIVISION
    rcall DIVISION_32_32    ; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4


    ; SPEICHERN
    STS(adr_LX_BYTE_1),temp1
    STS(adr_LX_BYTE_2),temp2
    STS(adr_LX_BYTE_3),temp3





    ; HILFSREGISTER wieder herstellen
    pop R8
    pop R7
    pop R6
    pop R5
    pop R4
    pop R3
    pop R2
    pop R1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; externer Schwingkreis
BERECHNUNG_LxCx:
    ; nur KALIBRIEREN
    rcall KALIBRIERUNG_START

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Ergebnis(1) und Ergebnis(2) aufrunden und halbieren (krzen)
ZWISCHENERGEBNISSE_HALBIEREN:
    ; Ergebnis 1 laden
    LDS temp1,(adr_ERGEBNIS_1_BYTE_1)
    LDS temp2,(adr_ERGEBNIS_1_BYTE_2)
    LDS temp3,(adr_ERGEBNIS_1_BYTE_3)
    LDS temp4,(adr_ERGEBNIS_1_BYTE_4)
    LDS temp5,(adr_ERGEBNIS_1_BYTE_5)
    LDS temp6,(adr_ERGEBNIS_1_BYTE_6)
    LDS temp7,(adr_ERGEBNIS_1_BYTE_7)
    LDS temp8,(adr_ERGEBNIS_1_BYTE_8)
    ; Aufrunden (+1)
    add temp1,EINS
    adc temp2,NULL
    adc temp3,NULL
    adc temp4,NULL
    adc temp5,NULL
    adc temp6,NULL
    adc temp7,NULL
    adc temp8,NULL
    ; 1 x rechts
    LSR temp8
    ROR temp7
    ROR temp6
    ROR temp5
    ROR temp4
    ROR temp3
    ROR temp2
    ROR temp1
    ; Ergebnis 1 speichern
    STS (adr_ERGEBNIS_1_BYTE_1),temp1
    STS (adr_ERGEBNIS_1_BYTE_2),temp2
    STS (adr_ERGEBNIS_1_BYTE_3),temp3
    STS (adr_ERGEBNIS_1_BYTE_4),temp4
    STS (adr_ERGEBNIS_1_BYTE_5),temp5
    STS (adr_ERGEBNIS_1_BYTE_6),temp6
    STS (adr_ERGEBNIS_1_BYTE_7),temp7
    STS (adr_ERGEBNIS_1_BYTE_8),temp8
;---------------------------------------
    ; Ergebnis 2 laden
    LDS temp1,(adr_ERGEBNIS_2_BYTE_1)
    LDS temp2,(adr_ERGEBNIS_2_BYTE_2)
    LDS temp3,(adr_ERGEBNIS_2_BYTE_3)
    LDS temp4,(adr_ERGEBNIS_2_BYTE_4)
    LDS temp5,(adr_ERGEBNIS_2_BYTE_5)
    LDS temp6,(adr_ERGEBNIS_2_BYTE_6)
    LDS temp7,(adr_ERGEBNIS_2_BYTE_7)
    LDS temp8,(adr_ERGEBNIS_2_BYTE_8)
    ; Aufrunden (+1)
    add temp1,EINS
    adc temp2,NULL
    adc temp3,NULL
    adc temp4,NULL
    adc temp5,NULL
    adc temp6,NULL
    adc temp7,NULL
    adc temp8,NULL
    ; 1 x rechts
    LSR temp8
    ROR temp7
    ROR temp6
    ROR temp5
    ROR temp4
    ROR temp3
    ROR temp2
    ROR temp1
    ; Ergebnis 2 speichern
    STS (adr_ERGEBNIS_2_BYTE_1),temp1
    STS (adr_ERGEBNIS_2_BYTE_2),temp2
    STS (adr_ERGEBNIS_2_BYTE_3),temp3
    STS (adr_ERGEBNIS_2_BYTE_4),temp4
    STS (adr_ERGEBNIS_2_BYTE_5),temp5
    STS (adr_ERGEBNIS_2_BYTE_6),temp6
    STS (adr_ERGEBNIS_2_BYTE_7),temp7
    STS (adr_ERGEBNIS_2_BYTE_8),temp8
ret

; ##############################################################################
; ##############################################################################
; ##############################################################################
HILFSRECHNUNG:
    ; HILFSREGISTER sichern
    push R1
    push R2
    push R3
    push R4
    push R5
    push R6
    push R7
    push R8
;------------------------------------------------------------------------------
    ; Frequenz f2 ermitteln    (mit Cx bzw mit Lx)
    LDS temp1,(adr_FREQUENZ_MOMENTAN_BYTE_1)
    LDS temp2,(adr_FREQUENZ_MOMENTAN_BYTE_2)
    LDS temp3,(adr_FREQUENZ_MOMENTAN_BYTE_3)
    ; SIMULATION aktiviert ?
    LDS temp,(adr_SIMULATION_AKTIV)
    tst temp
    breq HILFSRECHNUNG_NO_S
    ; TESTZAHLEN
    ldi temp1,BYTE1(f2)
    ldi temp2,BYTE2(f2)
    ldi temp3,BYTE3(f2)
HILFSRECHNUNG_NO_S:
    ; speichern
    STS(adr_FREQUENZ_F2_BYTE_1),temp1
    STS(adr_FREQUENZ_F2_BYTE_2),temp2
    STS(adr_FREQUENZ_F2_BYTE_3),temp3
    ; Frequenz f2 quadrieren
    LDS temp1,(adr_FREQUENZ_F2_BYTE_1)
    LDS temp2,(adr_FREQUENZ_F2_BYTE_2)
    LDS temp3,(adr_FREQUENZ_F2_BYTE_3)
    clr temp4
    LDS temp5,(adr_FREQUENZ_F2_BYTE_1)
    LDS temp6,(adr_FREQUENZ_F2_BYTE_2)
    LDS temp7,(adr_FREQUENZ_F2_BYTE_3)
    clr temp8
    rcall FUNKTION_MULTIPLIKATION_32_32    ; INP: TEMP1...4 / TEMP5...8 OUT: TEMP1...8
    ; ZWISCHEN-Ergebnis (2) speichern
    STS (adr_ERGEBNIS_2_BYTE_1),temp1
    STS (adr_ERGEBNIS_2_BYTE_2),temp2
    STS (adr_ERGEBNIS_2_BYTE_3),temp3
    STS (adr_ERGEBNIS_2_BYTE_4),temp4
    STS (adr_ERGEBNIS_2_BYTE_5),temp5
    STS (adr_ERGEBNIS_2_BYTE_6),temp6
    STS (adr_ERGEBNIS_2_BYTE_7),temp7
    STS (adr_ERGEBNIS_2_BYTE_8),temp8
;------------------------------------------------------------------------------
    ; 1. Schritt f1^2 mal 1000

    ; f1^2 laden
    LDS temp1,(adr_FREQUENZ_Q_F1_BYTE_1)
    LDS temp2,(adr_FREQUENZ_Q_F1_BYTE_2)
    LDS temp3,(adr_FREQUENZ_Q_F1_BYTE_3)
    LDS temp4,(adr_FREQUENZ_Q_F1_BYTE_4)
    LDS temp5,(adr_FREQUENZ_Q_F1_BYTE_5)
    LDS temp6,(adr_FREQUENZ_Q_F1_BYTE_6)
    clr temp7
    clr temp8
    ; Hilfsregister initialisiern
    mov R1,temp1
    mov R2,temp2
    mov R3,temp3
    mov R4,temp4
    mov R5,temp5
    mov R6,temp6
    mov R7,temp7
    mov R8,temp8
    ; Schleife initialisiern (Z-1)
    ldi ZL,LOW(1000)
    ldi ZH,HIGH (1000)
    sbiw ZL,1

    ; SCHLEIFE
HILFSRECHNUNG_SCHLEIFE:
    ; Multiplikation durch addition
    add temp1,R1
    adc temp2,R2
    adc temp3,R3
    adc temp4,R4
    adc temp5,R5
    adc temp6,R6
    adc temp7,R7
    adc temp8,R8
    ; Schleifenzhler minus 1
    sbiw ZL,1
    tst ZL
    brne HILFSRECHNUNG_SCHLEIFE
    tst ZH
    brne HILFSRECHNUNG_SCHLEIFE
    ; ZWISCHEN-Ergebnis(1) speichern
    STS (adr_ERGEBNIS_1_BYTE_1),temp1
    STS (adr_ERGEBNIS_1_BYTE_2),temp2
    STS (adr_ERGEBNIS_1_BYTE_3),temp3
    STS (adr_ERGEBNIS_1_BYTE_4),temp4
    STS (adr_ERGEBNIS_1_BYTE_5),temp5
    STS (adr_ERGEBNIS_1_BYTE_6),temp6
    STS (adr_ERGEBNIS_1_BYTE_7),temp7
    STS (adr_ERGEBNIS_1_BYTE_8),temp8

;------------------------------------------------------------------------------
    ; 2. Schritt solange krzen, bis 32 BIT ZAHLEN entstehen
    ; Umwandlung auf 32 Bit_Zahl
HILFSRECHNUNG_B8:
    LDS temp,(adr_ERGEBNIS_1_BYTE_8)    ; Byte 8 laden
    tst temp                            ; = NULL ?
    breq HILFSRECHNUNG_B7                ; ja => SPRUNG
    rcall ZWISCHENERGEBNISSE_HALBIEREN    ; Ergebnisse halbieren
    rjmp HILFSRECHNUNG_B8                ; erneute Prfung

HILFSRECHNUNG_B7:
    LDS temp,(adr_ERGEBNIS_1_BYTE_7)    ; Byte 7 laden
    tst temp                            ; = NULL ?
    breq HILFSRECHNUNG_B6                ; ja => SPRUNG
    rcall ZWISCHENERGEBNISSE_HALBIEREN    ; Ergebnisse halbieren
    rjmp HILFSRECHNUNG_B7                ; erneute Prfung

HILFSRECHNUNG_B6:
    LDS temp,(adr_ERGEBNIS_1_BYTE_6)    ; Byte 6 laden
    tst temp                            ; = NULL ?
    breq HILFSRECHNUNG_B5                ; ja => SPRUNG
    rcall ZWISCHENERGEBNISSE_HALBIEREN    ; Ergebnisse halbieren
    rjmp HILFSRECHNUNG_B6                ; erneute Prfung
HILFSRECHNUNG_B5:
    LDS temp,(adr_ERGEBNIS_1_BYTE_5)    ; Byte 5 laden
    tst temp                            ; = NULL ?
    breq HILFSRECHNUNG_B_FERTIG            ; ja => SPRUNG
    rcall ZWISCHENERGEBNISSE_HALBIEREN    ; Ergebnisse halbieren
    rjmp HILFSRECHNUNG_B5                ; erneute Prfung
HILFSRECHNUNG_B_FERTIG:
;-------------------------------------------
    ; 4. SCHRITT => DIVISION => ERGEBNIS 1  durch Ergebnis 2
    ; Ergebnis 1 laden
    LDS temp1,(adr_ERGEBNIS_1_BYTE_1)
    LDS temp2,(adr_ERGEBNIS_1_BYTE_2)
    LDS temp3,(adr_ERGEBNIS_1_BYTE_3)
    LDS temp4,(adr_ERGEBNIS_1_BYTE_4)
    ; Ergebnis 2 laden
    LDS temp5,(adr_ERGEBNIS_2_BYTE_1)
    LDS temp6,(adr_ERGEBNIS_2_BYTE_2)
    LDS temp7,(adr_ERGEBNIS_2_BYTE_3)
    LDS temp8,(adr_ERGEBNIS_2_BYTE_4)
    ; DIVISION
    rcall DIVISION_32_32    ; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4
;-------------------------------------------
    ; 4. SCHRITT => MINUS 1000
    ldi temp5,BYTE1(1000)
    ldi temp6,BYTE2(1000)
    ldi temp7,BYTE3(1000)
    ldi temp8,BYTE4(1000)

    sub temp1,temp5
    sbc temp2,temp6
    sbc temp3,temp7
    sbc temp4,temp8

    ; HILFSREGISTER wieder herstellen
    pop R8
    pop R7
    pop R6
    pop R5
    pop R4
    pop R3
    pop R2
    pop R1
ret

; ##############################################################################
; ##############################################################################
; ##############################################################################
HILFSRECHNUNG10:
    ; HILFSREGISTER sichern
    push R1
    push R2
    push R3
    push R4
    push R5
    push R6
    push R7
    push R8
;------------------------------------------------------------------------------
    ; Frequenz f2 ermitteln    (mit Cx bzw mit Lx)
    LDS temp1,(adr_FREQUENZ_MOMENTAN_BYTE_1)
    LDS temp2,(adr_FREQUENZ_MOMENTAN_BYTE_2)
    LDS temp3,(adr_FREQUENZ_MOMENTAN_BYTE_3)
    ; SIMULATION aktiviert ?
    LDS temp,(adr_SIMULATION_AKTIV)
    tst temp
    breq HILFSRECHNUNG10_NO_S
    ; TESTZAHLEN
    ldi temp1,BYTE1(f2)
    ldi temp2,BYTE2(f2)
    ldi temp3,BYTE3(f2)
HILFSRECHNUNG10_NO_S:
    ; speichern
    STS(adr_FREQUENZ_F2_BYTE_1),temp1
    STS(adr_FREQUENZ_F2_BYTE_2),temp2
    STS(adr_FREQUENZ_F2_BYTE_3),temp3
    ; Frequenz f2 quadrieren
    LDS temp1,(adr_FREQUENZ_F2_BYTE_1)
    LDS temp2,(adr_FREQUENZ_F2_BYTE_2)
    LDS temp3,(adr_FREQUENZ_F2_BYTE_3)
    clr temp4
    LDS temp5,(adr_FREQUENZ_F2_BYTE_1)
    LDS temp6,(adr_FREQUENZ_F2_BYTE_2)
    LDS temp7,(adr_FREQUENZ_F2_BYTE_3)
    clr temp8
    rcall FUNKTION_MULTIPLIKATION_32_32    ; INP: TEMP1...4 / TEMP5...8 OUT: TEMP1...8
    ; ZWISCHEN-Ergebnis (2) speichern
    STS (adr_ERGEBNIS_2_BYTE_1),temp1
    STS (adr_ERGEBNIS_2_BYTE_2),temp2
    STS (adr_ERGEBNIS_2_BYTE_3),temp3
    STS (adr_ERGEBNIS_2_BYTE_4),temp4
    STS (adr_ERGEBNIS_2_BYTE_5),temp5
    STS (adr_ERGEBNIS_2_BYTE_6),temp6
    STS (adr_ERGEBNIS_2_BYTE_7),temp7
    STS (adr_ERGEBNIS_2_BYTE_8),temp8
;------------------------------------------------------------------------------
    ; 1. Schritt f1^2 mal 10000

    ; f1^2 laden
    LDS temp1,(adr_FREQUENZ_Q_F1_BYTE_1)
    LDS temp2,(adr_FREQUENZ_Q_F1_BYTE_2)
    LDS temp3,(adr_FREQUENZ_Q_F1_BYTE_3)
    LDS temp4,(adr_FREQUENZ_Q_F1_BYTE_4)
    LDS temp5,(adr_FREQUENZ_Q_F1_BYTE_5)
    LDS temp6,(adr_FREQUENZ_Q_F1_BYTE_6)
    clr temp7
    clr temp8
    ; Hilfsregister initialisiern
    mov R1,temp1
    mov R2,temp2
    mov R3,temp3
    mov R4,temp4
    mov R5,temp5
    mov R6,temp6
    mov R7,temp7
    mov R8,temp8
    ; Schleife initialisiern (Z-1)
    ldi ZL,LOW(10000)
    ldi ZH,HIGH (10000)
    sbiw ZL,1

    ; SCHLEIFE
HILFSRECHNUNG10_SCHLEIFE:
    ; Multiplikation durch addition
    add temp1,R1
    adc temp2,R2
    adc temp3,R3
    adc temp4,R4
    adc temp5,R5
    adc temp6,R6
    adc temp7,R7
    adc temp8,R8
    ; Schleifenzhler minus 1
    sbiw ZL,1
    tst ZL
    brne HILFSRECHNUNG10_SCHLEIFE
    tst ZH
    brne HILFSRECHNUNG10_SCHLEIFE
    ; ZWISCHEN-Ergebnis(1) speichern
    STS (adr_ERGEBNIS_1_BYTE_1),temp1
    STS (adr_ERGEBNIS_1_BYTE_2),temp2
    STS (adr_ERGEBNIS_1_BYTE_3),temp3
    STS (adr_ERGEBNIS_1_BYTE_4),temp4
    STS (adr_ERGEBNIS_1_BYTE_5),temp5
    STS (adr_ERGEBNIS_1_BYTE_6),temp6
    STS (adr_ERGEBNIS_1_BYTE_7),temp7
    STS (adr_ERGEBNIS_1_BYTE_8),temp8

;------------------------------------------------------------------------------
    ; 2. Schritt solange krzen, bis 32 BIT ZAHLEN entstehen
    ; Umwandlung auf 32 Bit_Zahl
HILFSRECHNUNG10_B8:
    LDS temp,(adr_ERGEBNIS_1_BYTE_8)    ; Byte 8 laden
    tst temp                            ; = NULL ?
    breq HILFSRECHNUNG10_B7                ; ja => SPRUNG
    rcall ZWISCHENERGEBNISSE_HALBIEREN    ; Ergebnisse halbieren
    rjmp HILFSRECHNUNG10_B8                ; erneute Prfung

HILFSRECHNUNG10_B7:
    LDS temp,(adr_ERGEBNIS_1_BYTE_7)    ; Byte 7 laden
    tst temp                            ; = NULL ?
    breq HILFSRECHNUNG10_B6                ; ja => SPRUNG
    rcall ZWISCHENERGEBNISSE_HALBIEREN    ; Ergebnisse halbieren
    rjmp HILFSRECHNUNG10_B7                ; erneute Prfung

HILFSRECHNUNG10_B6:
    LDS temp,(adr_ERGEBNIS_1_BYTE_6)    ; Byte 6 laden
    tst temp                            ; = NULL ?
    breq HILFSRECHNUNG10_B5                ; ja => SPRUNG
    rcall ZWISCHENERGEBNISSE_HALBIEREN    ; Ergebnisse halbieren
    rjmp HILFSRECHNUNG10_B6                ; erneute Prfung
HILFSRECHNUNG10_B5:
    LDS temp,(adr_ERGEBNIS_1_BYTE_5)    ; Byte 5 laden
    tst temp                            ; = NULL ?
    breq HILFSRECHNUNG10_B_FERTIG            ; ja => SPRUNG
    rcall ZWISCHENERGEBNISSE_HALBIEREN    ; Ergebnisse halbieren
    rjmp HILFSRECHNUNG10_B5                ; erneute Prfung
HILFSRECHNUNG10_B_FERTIG:
;-------------------------------------------
    ; 4. SCHRITT => DIVISION => ERGEBNIS 1  durch Ergebnis 2
    ; Ergebnis 1 laden
    LDS temp1,(adr_ERGEBNIS_1_BYTE_1)
    LDS temp2,(adr_ERGEBNIS_1_BYTE_2)
    LDS temp3,(adr_ERGEBNIS_1_BYTE_3)
    LDS temp4,(adr_ERGEBNIS_1_BYTE_4)
    ; Ergebnis 2 laden
    LDS temp5,(adr_ERGEBNIS_2_BYTE_1)
    LDS temp6,(adr_ERGEBNIS_2_BYTE_2)
    LDS temp7,(adr_ERGEBNIS_2_BYTE_3)
    LDS temp8,(adr_ERGEBNIS_2_BYTE_4)
    ; DIVISION
    rcall DIVISION_32_32    ; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4
;-------------------------------------------
    ; 4. SCHRITT => MINUS 10000
    ldi temp5,BYTE1(10000)
    ldi temp6,BYTE2(10000)
    ldi temp7,BYTE3(10000)
    ldi temp8,BYTE4(10000)

    sub temp1,temp5
    sbc temp2,temp6
    sbc temp3,temp7
    sbc temp4,temp8

    ; HILFSREGISTER wieder herstellen
    pop R8
    pop R7
    pop R6
    pop R5
    pop R4
    pop R3
    pop R2
    pop R1
ret

; ##############################################################################
; ##############################################################################
; ##############################################################################
HILFSRECHNUNG100:
    ; HILFSREGISTER sichern
    push R1
    push R2
    push R3
    push R4
    push R5
    push R6
    push R7
    push R8
;------------------------------------------------------------------------------
    ; Frequenz f2 ermitteln    (mit Cx bzw mit Lx)
    LDS temp1,(adr_FREQUENZ_MOMENTAN_BYTE_1)
    LDS temp2,(adr_FREQUENZ_MOMENTAN_BYTE_2)
    LDS temp3,(adr_FREQUENZ_MOMENTAN_BYTE_3)
    ; SIMULATION aktiviert ?
    LDS temp,(adr_SIMULATION_AKTIV)
    tst temp
    breq HILFSRECHNUNG100_NO_S
    ; TESTZAHLEN
    ldi temp1,BYTE1(f2)
    ldi temp2,BYTE2(f2)
    ldi temp3,BYTE3(f2)
HILFSRECHNUNG100_NO_S:
    ; speichern
    STS(adr_FREQUENZ_F2_BYTE_1),temp1
    STS(adr_FREQUENZ_F2_BYTE_2),temp2
    STS(adr_FREQUENZ_F2_BYTE_3),temp3
    ; Frequenz f2 quadrieren
    LDS temp1,(adr_FREQUENZ_F2_BYTE_1)
    LDS temp2,(adr_FREQUENZ_F2_BYTE_2)
    LDS temp3,(adr_FREQUENZ_F2_BYTE_3)
    clr temp4
    LDS temp5,(adr_FREQUENZ_F2_BYTE_1)
    LDS temp6,(adr_FREQUENZ_F2_BYTE_2)
    LDS temp7,(adr_FREQUENZ_F2_BYTE_3)
    clr temp8
    rcall FUNKTION_MULTIPLIKATION_32_32    ; INP: TEMP1...4 / TEMP5...8 OUT: TEMP1...8
    ; ZWISCHEN-Ergebnis (2) speichern
    STS (adr_ERGEBNIS_2_BYTE_1),temp1
    STS (adr_ERGEBNIS_2_BYTE_2),temp2
    STS (adr_ERGEBNIS_2_BYTE_3),temp3
    STS (adr_ERGEBNIS_2_BYTE_4),temp4
    STS (adr_ERGEBNIS_2_BYTE_5),temp5
    STS (adr_ERGEBNIS_2_BYTE_6),temp6
    STS (adr_ERGEBNIS_2_BYTE_7),temp7
    STS (adr_ERGEBNIS_2_BYTE_8),temp8
;------------------------------------------------------------------------------
    ; 1. Schritt f1^2 mal 10000

    ; f1^2 laden
    LDS temp1,(adr_FREQUENZ_Q_F1_BYTE_1)
    LDS temp2,(adr_FREQUENZ_Q_F1_BYTE_2)
    LDS temp3,(adr_FREQUENZ_Q_F1_BYTE_3)
    LDS temp4,(adr_FREQUENZ_Q_F1_BYTE_4)
    LDS temp5,(adr_FREQUENZ_Q_F1_BYTE_5)
    LDS temp6,(adr_FREQUENZ_Q_F1_BYTE_6)
    clr temp7
    clr temp8
    ; Hilfsregister initialisiern
    mov R1,temp1
    mov R2,temp2
    mov R3,temp3
    mov R4,temp4
    mov R5,temp5
    mov R6,temp6
    mov R7,temp7
    mov R8,temp8
    ; Schleife initialisiern (Z-1)
    ldi ZL,LOW(10000)
    ldi ZH,HIGH (10000)
    sbiw ZL,1

    ; SCHLEIFE 10000
HILFSRECHNUNG100_SCHLEIFE:
    ; Multiplikation durch addition
    add temp1,R1
    adc temp2,R2
    adc temp3,R3
    adc temp4,R4
    adc temp5,R5
    adc temp6,R6
    adc temp7,R7
    adc temp8,R8
    ; Schleifenzhler minus 1
    sbiw ZL,1
    tst ZL
    brne HILFSRECHNUNG100_SCHLEIFE
    tst ZH
    brne HILFSRECHNUNG100_SCHLEIFE

    ;den 10000-fachen Wert in die Register schaffen und nochmal
    ;verzehnfachen
    mov R1,temp1
    mov R2,temp2
    mov R3,temp3
    mov R4,temp4
    mov R5,temp5
    mov R6,temp6
    mov R7,temp7
    mov R8,temp8
    ; Schleife initialisiern (Z-1)
    ldi ZL,LOW(10)
    ldi ZH,HIGH (10)
    sbiw ZL,1

    ; SCHLEIFE 10
HILFSRECHNUNG100a_SCHLEIFE:
    ; Multiplikation durch addition
    add temp1,R1
    adc temp2,R2
    adc temp3,R3
    adc temp4,R4
    adc temp5,R5
    adc temp6,R6
    adc temp7,R7
    adc temp8,R8
    ; Schleifenzhler minus 1
    sbiw ZL,1
    tst ZL
    brne HILFSRECHNUNG100a_SCHLEIFE
    tst ZH
    brne HILFSRECHNUNG100a_SCHLEIFE

    ; ZWISCHEN-Ergebnis(1) speichern
    STS (adr_ERGEBNIS_1_BYTE_1),temp1
    STS (adr_ERGEBNIS_1_BYTE_2),temp2
    STS (adr_ERGEBNIS_1_BYTE_3),temp3
    STS (adr_ERGEBNIS_1_BYTE_4),temp4
    STS (adr_ERGEBNIS_1_BYTE_5),temp5
    STS (adr_ERGEBNIS_1_BYTE_6),temp6
    STS (adr_ERGEBNIS_1_BYTE_7),temp7
    STS (adr_ERGEBNIS_1_BYTE_8),temp8

;------------------------------------------------------------------------------
    ; 2. Schritt solange krzen, bis 32 BIT ZAHLEN entstehen
    ; Umwandlung auf 32 Bit_Zahl
HILFSRECHNUNG100_B8:
    LDS temp,(adr_ERGEBNIS_1_BYTE_8)    ; Byte 8 laden
    tst temp                            ; = NULL ?
    breq HILFSRECHNUNG100_B7                ; ja => SPRUNG
    rcall ZWISCHENERGEBNISSE_HALBIEREN    ; Ergebnisse halbieren
    rjmp HILFSRECHNUNG100_B8                ; erneute Prfung

HILFSRECHNUNG100_B7:
    LDS temp,(adr_ERGEBNIS_1_BYTE_7)    ; Byte 7 laden
    tst temp                            ; = NULL ?
    breq HILFSRECHNUNG100_B6                ; ja => SPRUNG
    rcall ZWISCHENERGEBNISSE_HALBIEREN    ; Ergebnisse halbieren
    rjmp HILFSRECHNUNG100_B7                ; erneute Prfung

HILFSRECHNUNG100_B6:
    LDS temp,(adr_ERGEBNIS_1_BYTE_6)    ; Byte 6 laden
    tst temp                            ; = NULL ?
    breq HILFSRECHNUNG100_B5                ; ja => SPRUNG
    rcall ZWISCHENERGEBNISSE_HALBIEREN    ; Ergebnisse halbieren
    rjmp HILFSRECHNUNG100_B6                ; erneute Prfung
HILFSRECHNUNG100_B5:
    LDS temp,(adr_ERGEBNIS_1_BYTE_5)    ; Byte 5 laden
    tst temp                            ; = NULL ?
    breq HILFSRECHNUNG100_B_FERTIG            ; ja => SPRUNG
    rcall ZWISCHENERGEBNISSE_HALBIEREN    ; Ergebnisse halbieren
    rjmp HILFSRECHNUNG100_B5                ; erneute Prfung
HILFSRECHNUNG100_B_FERTIG:
;-------------------------------------------
    ; 4. SCHRITT => DIVISION => ERGEBNIS 1  durch Ergebnis 2
    ; Ergebnis 1 laden
    LDS temp1,(adr_ERGEBNIS_1_BYTE_1)
    LDS temp2,(adr_ERGEBNIS_1_BYTE_2)
    LDS temp3,(adr_ERGEBNIS_1_BYTE_3)
    LDS temp4,(adr_ERGEBNIS_1_BYTE_4)
    ; Ergebnis 2 laden
    LDS temp5,(adr_ERGEBNIS_2_BYTE_1)
    LDS temp6,(adr_ERGEBNIS_2_BYTE_2)
    LDS temp7,(adr_ERGEBNIS_2_BYTE_3)
    LDS temp8,(adr_ERGEBNIS_2_BYTE_4)
    ; DIVISION
    rcall DIVISION_32_32    ; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4
;-------------------------------------------
    ; 4. SCHRITT => MINUS 100000
    ldi temp5,BYTE1(100000)
    ldi temp6,BYTE2(100000)
    ldi temp7,BYTE3(100000)
    ldi temp8,BYTE4(100000)

    sub temp1,temp5
    sbc temp2,temp6
    sbc temp3,temp7
    sbc temp4,temp8

    ; HILFSREGISTER wieder herstellen
    pop R8
    pop R7
    pop R6
    pop R5
    pop R4
    pop R3
    pop R2
    pop R1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################