; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_MENUE:
    ; TASTE
    LDS temp,(adr_TASTE)
    ; Menue + gedrckt ?
    cpi temp,(TASTE_MENUE_PLUS)
    breq ANZEIGE_MENUE_PLUS
    ; Menue - gedrckt ?
    cpi temp,(TASTE_MENUE_MINUS)
    breq ANZEIGE_MENUE_MINUS
    rjmp ANZEIGE_MENUE_START
;---------------------------------------------
ANZEIGE_MENUE_PLUS:
    LDS temp,(adr_MENUE)
    inc temp
    STS (adr_MENUE),temp
    rjmp ANZEIGE_MENUE_START
;---------------------------------------------
ANZEIGE_MENUE_MINUS:
    LDS temp,(adr_MENUE)
    dec temp
    STS (adr_MENUE),temp
    ; FEHLERPRFUNG
    tst temp
    brpl ANZEIGE_MENUE_START
    ; MENUE und EBENE = NULL
    STS (adr_MENUE),NULL
    STS (adr_MENUE_EBENE),NULL
    rjmp ANZEIGE_MENUE_START
;---------------------------------------------
ANZEIGE_MENUE_START:
    ; MENUE EBENE = NULL ?
    LDS temp,(adr_MENUE_EBENE)
    tst temp
    breq ANZEIGE_MENUE_START_w
    ret
ANZEIGE_MENUE_START_w:
;---------------------------------------------
    LDS temp,(adr_MENUE)
    ; Z-ZEIGER initialisieren
    ldi ZL,low (ANZEIGE_MENUE_SPRUNGMARKE)
    ldi ZH,high(ANZEIGE_MENUE_SPRUNGMARKE)

    add ZL,temp
    adc ZH,NULL
    IJMP        ; SPRUNG nach Z

ANZEIGE_MENUE_SPRUNGMARKE:
    rjmp ANZEIGE_HAUPTMENUE
    rjmp ANZEIGE_L_C
    rjmp ANZEIGE_FREQUENZ_AKTUELL
    rjmp ANZEIGE_FREQUENZ_KALIBRIERUNG
    rjmp ANZEIGE_EDIT_VIEW
    rjmp ANZEIGE_LEER_MENUE
    rjmp ANZEIGE_LEER_MENUE
    rjmp ANZEIGE_LEER_MENUE

    ; FEHLER
    STS (adr_MENUE),NULL
    STS (adr_MENUE_EBENE),NULL
    rjmp ANZEIGE_MENUE_START
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_MENUE_EBENE_1:
    LDS temp,(adr_MENUE_EBENE)
    tst temp
    brne ANZEIGE_MENUE_EBENE_1_START
    ret
ANZEIGE_MENUE_EBENE_1_START:
;---------------------------------------------
    ; MENUE LADEN
    LDS temp,(adr_MENUE)
    ; Z-ZEIGER initialisieren
    ldi ZL,low (ANZEIGE_MENUE_EBENE_SPRUNGMARKE)
    ldi ZH,high(ANZEIGE_MENUE_EBENE_SPRUNGMARKE)

    add ZL,temp
    adc ZH,NULL
    IJMP        ; SPRUNG nach Z

ANZEIGE_MENUE_EBENE_SPRUNGMARKE:
    rjmp ANZEIGE_HILFE_TASTE
    rjmp ANZEIGE_PROGRAMMSTARTS
    rjmp ANZEIGE_EDIT_REFERENZ_C
    rjmp ANZEIGE_RESET
    rjmp ANZEIGE_EDIT_SIMULATION_AKTIVIEREN
    rjmp ANZEIGE_TASTE
    rjmp ANZEIGE_WERKSEINSTELLUNG_1nF
    rjmp ANZEIGE_WERKSEINSTELLUNG_2nF
    rjmp ANZEIGE_WERKSEINSTELLUNG_3nF
    rjmp ANZEIGE_WERKSEINSTELLUNG_4nF
    rjmp ANZEIGE_WERKSEINSTELLUNG_5nF
    rjmp ANZEIGE_WERKSEINSTELLUNG_10nF
    rjmp ANZEIGE_WERKSEINSTELLUNG_60nF
    rjmp ANZEIGE_LEER_MENUE
    rjmp ANZEIGE_LEER_MENUE
    rjmp ANZEIGE_LEER_MENUE

    ; FEHLER
    STS (adr_MENUE),NULL
    rjmp ANZEIGE_MENUE_EBENE_1

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_HAUPTMENUE:
    LDS temp,(adr_MODUS)
    ; Z-ZEIGER initialisieren
    ldi ZL,low (ANZEIGE_HAUPTMENUE_SPRUNGMARKE)
    ldi ZH,high(ANZEIGE_HAUPTMENUE_SPRUNGMARKE)

    add ZL,temp
    adc ZH,NULL
    IJMP        ; SPRUNG nach Z
ANZEIGE_HAUPTMENUE_SPRUNGMARKE:
    rjmp ANZEIGE_HAUPTMENUE_0
    rjmp ANZEIGE_HAUPTMENUE_1
    rjmp ANZEIGE_HAUPTMENUE_2
    rjmp ANZEIGE_HAUPTMENUE_3
    rjmp ANZEIGE_LEER_MENUE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Cx mit 1 Kommastelle
ANZEIGE_HAUPTMENUE_0:
    ; CLEAR
    rcall LCD_CLEAR
    ; ZEILE 1
    ldi ZH, high(TEXT_MODUS_0*2)    ; TEXT
    ldi ZL,  low(TEXT_MODUS_0*2)
    rcall ANZEIGE_TEXT

    ; ZEILE 2
    rcall LCD_ZEILE2
    ldi temp, 'C'        ;
    rcall LCD_DATA
    ldi temp, 'x'        ;
    rcall LCD_DATA
    ldi temp, '='        ;
    rcall LCD_DATA
    ; Kapazitt anzeigen
    LDS temp1,(adr_CX_BYTE_1)
    LDS temp2,(adr_CX_BYTE_2)
    LDS temp3,(adr_CX_BYTE_3)
    clr temp4
    rcall FUNKTION_HEX_ASC_32    ; INPUT: temp1...4 OUTPUT: Temp1...8
    rcall LCD_FORMAT_M1K
    rcall LCD_AUSGABE_ZAHL_9_STELLEN_KURZ
    ; Maeinheit
    rcall LCD_SPACE
    rcall LCD_DATA
    ldi temp, 'p'        ;
    rcall LCD_DATA
    ldi temp, 'F'        ;
    rcall LCD_DATA
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Lx REIHE mit 2 Kommastellen
ANZEIGE_HAUPTMENUE_1:
    ; CLEAR
    rcall LCD_CLEAR
    ; ZEILE 1
    ldi ZH, high(TEXT_MODUS_1*2)    ; TEXT
    ldi ZL,  low(TEXT_MODUS_1*2)
    rcall ANZEIGE_TEXT

    ; ZEILE 2
    rcall LCD_ZEILE2
    ldi temp, 'L'        ;
    rcall LCD_DATA
    ldi temp, 'x'        ;
    rcall LCD_DATA
    ldi temp, '='        ;
    rcall LCD_DATA

    ; Induktivitt anzeigen
    LDS temp1,(adr_LX_BYTE_1)
    LDS temp2,(adr_LX_BYTE_2)
    LDS temp3,(adr_LX_BYTE_3)
    clr temp4
    rcall FUNKTION_HEX_ASC_32    ; INPUT: temp1...4 OUTPUT: Temp1...8
    rcall LCD_FORMAT_M2K
    rcall LCD_AUSGABE_ZAHL_9_STELLEN_KURZ
    ; Maeinheit
    rcall LCD_SPACE
    rcall LCD_DATA
    ldi temp, 228        ; 
    rcall LCD_DATA
    ldi temp, 'H'        ;
    rcall LCD_DATA


ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Lx parallel
ANZEIGE_HAUPTMENUE_2:
    ; CLEAR
    rcall LCD_CLEAR
    ; ZEILE 1
    ldi ZH, high(TEXT_MODUS_2*2)    ; TEXT
    ldi ZL,  low(TEXT_MODUS_2*2)
    rcall ANZEIGE_TEXT

    ; ZEILE 2
    rcall LCD_ZEILE2
    ldi temp, 'L'        ;
    rcall LCD_DATA
    ldi temp, 'x'        ;
    rcall LCD_DATA
    ldi temp, '='        ;
    rcall LCD_DATA

    ; Induktivitt anzeigen
    LDS temp1,(adr_LX_BYTE_1)
    LDS temp2,(adr_LX_BYTE_2)
    LDS temp3,(adr_LX_BYTE_3)
    clr temp4
    rcall FUNKTION_HEX_ASC_32    ; INPUT: temp1...4 OUTPUT: Temp1...8
    rcall LCD_FORMAT
    rcall LCD_AUSGABE_ZAHL_9_STELLEN_KURZ
    ; Maeinheit
    rcall LCD_SPACE
    rcall LCD_DATA
    ldi temp, 228        ; 
    rcall LCD_DATA
    ldi temp, 'H'        ;
    rcall LCD_DATA
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; LC-SCHWINGKREIS
ANZEIGE_HAUPTMENUE_3:
    ; CLEAR
    rcall LCD_CLEAR
    ; ZEILE 1
    ldi ZH, high(TEXT_MODUS_3*2)    ; TEXT
    ldi ZL,  low(TEXT_MODUS_3*2)
    rcall ANZEIGE_TEXT

    ; ZEILE 2
    rcall LCD_ZEILE2

    ; INDUKTIVITT
    LDS temp1,(adr_INDUKTIVITAET_BYTE_1)
    LDS temp2,(adr_INDUKTIVITAET_BYTE_2)
    LDS temp3,(adr_INDUKTIVITAET_BYTE_3)
    clr temp4
    rcall FUNKTION_HEX_ASC_32    ; INPUT: temp1...4 OUTPUT: Temp1...8
    rcall LCD_FORMAT
    rcall LCD_AUSGABE_ZAHL_7_STELLEN_KURZ
    ; Maeinheit
    ldi temp, 228        ; 
    rcall LCD_DATA

    ; KAPAZITT
    LDS temp1,(adr_KAPAZITAET_BYTE_1)
    LDS temp2,(adr_KAPAZITAET_BYTE_2)
    LDS temp3,(adr_KAPAZITAET_BYTE_3)
    clr temp4
    rcall FUNKTION_HEX_ASC_32    ; INPUT: temp1...4 OUTPUT: Temp1...8
    rcall LCD_FORMAT
    rcall LCD_AUSGABE_ZAHL_7_STELLEN_KURZ
    ; Maeinheit
    ldi temp, 'p'        ;
    rcall LCD_DATA

ret