

;
; LC-METER fr ATmega8
; Bernhard.Erfurt@gmx.de
; 01/2007
;

;
; Anschlussbelegung PINS
;
; PB0 ==> LCD D4
; PB1 ==> LCD D5
; PB2 ==> LCD D6
; PB3 ==> LCD D7
; PB4 ==> LCD RS
; PB5 ==> LCD ENABLE
; PB6 ==> Quarz
; PB7 ==> Quarz
;
; PC0 ==> RELAIS Referenz C    gegen GND
; PC1 ==> RELAIS C gegen GND
; PC2 ==> RELAIS L gegen GND
; PC3 ==> RELAIS L Serie zum Ausgang
; PC4 ==> RELAIS direkt zum Ausgang
; PC5 ==> LED-MODUS
;
; PD0 ==> TASTE MENUE PLUS
; PD1 ==> TASTE MENUE MINUS
; PD2 ==> TASTE PLUS
; PD3 ==> TASTE MINUS
; PD4 ==> TASTE START
; PD5 ==> EINGANG Frequenzzhler
; PD6 ==> TASTE KALIBRIERUNG
; PD7 ==> TASTE MODUS
;


; ATmega8
.include "m8def.inc"

; KONSTANTEN
.equ TAKT        =16000000            ; 16 MHz

; TIMER-WERTE
.equ TIMERWERT0 =256-250            ;(2 hoch 8  minus...)        bei 16MHz + Vorteiler   64 => 0.001s

; TESTFREQUENZEN
.equ F1                    =  193962    ; Leerlauffrequenz
.equ F2                    =   91136    ; Frequenz mit Cx / Lx / Cref
.equ F2_L_P                =  274304     ; FREQUENZ bei parallel Lx
; RELAIS
.equ RELAIS_C_REF            = 0
.equ RELAIS_C                = 1
.equ RELAIS_L_GND            = 2
.equ RELAIS_L_REIHE            = 3
.equ RELAIS_DIREKT            = 4

; LED MODUS
.equ LED_C_MODUS            = 5

; TASTEN
.equ TASTE_MENUE_PLUS        = 1
.equ TASTE_MENUE_MINUS        = 2
.equ TASTE_PLUS                = 4
.equ TASTE_MINUS            = 8
.equ TASTE_START_MESSUNG    = 16
.equ TASTE_KALIBRIERUNG        = 64
.equ TASTE_MODUS            = 128
; LCD
.equ LCD_PORT                = PORTB
.equ LCD_D0                    = 0
.equ LCD_D1                    = 1
.equ LCD_D2                    = 2
.equ LCD_D3                    = 3
.equ LCD_RS                    = 4
.equ LCD_E                    = 5

; SRAM-BELEGUNG ATmega8
.equ adr_DATEN                                =0x0060            ; 0x0060 START Adresse

.equ adr_TASTE                                =0x0060+2

.equ adr_MODUS                                =0x0060+3

.equ adr_MENUE                                =0x0060+4
.equ adr_MENUE_EBENE                        =0x0060+5

.equ adr_KONFIGURATION_SPEICHERN            =0x0060+6            ; 1= Konfiguration in EEPROM speichern

.equ adr_SIMULATION_AKTIV                    =0x0060+9

.equ adr_ss1000_L                            =0x0060+10            ; 1000-tel SEKUNDE
.equ adr_ss1000_H                            =0x0060+11            ; 1000-tel SEKUNDE

.equ adr_WERKSEINSTELLUNG_C_REF_BYTE_1        =0x0060+14            ; Werkseinstellung
.equ adr_WERKSEINSTELLUNG_C_REF_BYTE_2        =0x0060+15

.equ adr_REFERENZ_C_BYTE_1                    =0x0060+17            ; Referenzkondensator Bsp: 3520pF
.equ adr_REFERENZ_C_BYTE_2                    =0x0060+18

.equ adr_INDUKTIVITAET_BYTE_1                =0x0060+20            ; Induktivitt Bsp 8200H
.equ adr_INDUKTIVITAET_BYTE_2                =0x0060+21
.equ adr_INDUKTIVITAET_BYTE_3                =0x0060+22

.equ adr_KAPAZITAET_BYTE_1                    =0x0060+23            ; KAPAZITT        Bsp: 8085pF
.equ adr_KAPAZITAET_BYTE_2                    =0x0060+24
.equ adr_KAPAZITAET_BYTE_3                    =0x0060+25


.equ adr_CX_BYTE_1                            =0x0060+30            ; Ergebnis Cx
.equ adr_CX_BYTE_2                            =0x0060+31
.equ adr_CX_BYTE_3                            =0x0060+32

.equ adr_LX_BYTE_1                            =0x0060+33            ; Ergebnis LX
.equ adr_LX_BYTE_2                            =0x0060+34
.equ adr_LX_BYTE_3                            =0x0060+35

.equ adr_FREQUENZ_MOMENTAN_BYTE_1            =0x0060+50            ; Momentane Frequenz
.equ adr_FREQUENZ_MOMENTAN_BYTE_2            =0x0060+51
.equ adr_FREQUENZ_MOMENTAN_BYTE_3            =0x0060+52

.equ adr_FREQUENZ_UEBERLAUF                    =0x0060+53            ; berlauf


.equ adr_FREQUENZ_F1_BYTE_1                    =0x0060+60            ; Frequenz Leerlauf
.equ adr_FREQUENZ_F1_BYTE_2                    =0x0060+61
.equ adr_FREQUENZ_F1_BYTE_3                    =0x0060+62

.equ adr_FREQUENZ_F2_BYTE_1                    =0x0060+70            ; Frequenz 2 (mit Cx / LX / Cref)
.equ adr_FREQUENZ_F2_BYTE_2                    =0x0060+71
.equ adr_FREQUENZ_F2_BYTE_3                    =0x0060+72

.equ adr_FREQUENZ_KALI_BYTE_1                =0x0060+80            ; Frequenz Kalibrierung (mit Cref)
.equ adr_FREQUENZ_KALI_BYTE_2                =0x0060+81
.equ adr_FREQUENZ_KALI_BYTE_3                =0x0060+82


.equ adr_FREQUENZ_Q_F1_BYTE_1                =0x0060+200            ; Quadrat Frequenz f1 (Leerlauf)
.equ adr_FREQUENZ_Q_F1_BYTE_2                =0x0060+201
.equ adr_FREQUENZ_Q_F1_BYTE_3                =0x0060+202
.equ adr_FREQUENZ_Q_F1_BYTE_4                =0x0060+203
.equ adr_FREQUENZ_Q_F1_BYTE_5                =0x0060+204
.equ adr_FREQUENZ_Q_F1_BYTE_6                =0x0060+205

.equ adr_FREQUENZ_Q_F2_BYTE_1                =0x0060+210            ; Quadrat Frequenz f2
.equ adr_FREQUENZ_Q_F2_BYTE_2                =0x0060+211
.equ adr_FREQUENZ_Q_F2_BYTE_3                =0x0060+212
.equ adr_FREQUENZ_Q_F2_BYTE_4                =0x0060+213
.equ adr_FREQUENZ_Q_F2_BYTE_5                =0x0060+214
.equ adr_FREQUENZ_Q_F2_BYTE_6                =0x0060+215

.equ adr_ERGEBNIS_1_BYTE_1                    =0x0060+300            ; Zwischenergebnis (1)
.equ adr_ERGEBNIS_1_BYTE_2                    =0x0060+301
.equ adr_ERGEBNIS_1_BYTE_3                    =0x0060+302
.equ adr_ERGEBNIS_1_BYTE_4                    =0x0060+303
.equ adr_ERGEBNIS_1_BYTE_5                    =0x0060+304
.equ adr_ERGEBNIS_1_BYTE_6                    =0x0060+305
.equ adr_ERGEBNIS_1_BYTE_7                    =0x0060+306
.equ adr_ERGEBNIS_1_BYTE_8                    =0x0060+307

.equ adr_ERGEBNIS_2_BYTE_1                    =0x0060+310            ; Zwischenergebnis (2)
.equ adr_ERGEBNIS_2_BYTE_2                    =0x0060+311
.equ adr_ERGEBNIS_2_BYTE_3                    =0x0060+312
.equ adr_ERGEBNIS_2_BYTE_4                    =0x0060+313
.equ adr_ERGEBNIS_2_BYTE_5                    =0x0060+314
.equ adr_ERGEBNIS_2_BYTE_6                    =0x0060+315
.equ adr_ERGEBNIS_2_BYTE_7                    =0x0060+316
.equ adr_ERGEBNIS_2_BYTE_8                    =0x0060+317

.equ adr_TEST_A_BYTE_1                        =0x0060+500            ; zum TESTEN
.equ adr_TEST_A_BYTE_2                        =0x0060+501
.equ adr_TEST_A_BYTE_3                        =0x0060+502
.equ adr_TEST_A_BYTE_4                        =0x0060+503
.equ adr_TEST_A_BYTE_5                        =0x0060+504
.equ adr_TEST_A_BYTE_6                        =0x0060+505
.equ adr_TEST_A_BYTE_7                        =0x0060+506
.equ adr_TEST_A_BYTE_8                        =0x0060+507


; EEPROM-BELEGUNG ATmega8
.equ adr_EEPROM_DATEN_0    = 0

.equ adr_EEPROM_REF_C_BYTE_0                = 0
.equ adr_EEPROM_REF_C_BYTE_1                = 1

.equ adr_EEPROM_ANZAHL_STARTS_L                = 10
.equ adr_EEPROM_ANZAHL_STARTS_H                = 10
; REGISTER

.def NULL     = R14
.def EINS     = R15

.def temp     = R16
.def temp1     = R17
.def temp2     = R18
.def temp3     = R19
.def temp4     = R20
.def temp5     = R21
.def temp6     = R22
.def temp7     = R23
.def temp8     = R24
.def temp9     = R25





.cseg                    ;Beginn eines Code-Segmentes
.org 0                    ;Startadresse=0

rjmp RESET              ; Reset Handler
rjmp INTERRUPT_ERROR    ;rjmp EXT_INT0   ; IRQ0 Handler
rjmp INTERRUPT_ERROR    ;rjmp EXT_INT1   ; IRQ1 Handler
rjmp INTERRUPT_ERROR    ;rjmp TIM2_COMP  ; Timer2 Compare Handler
rjmp INTERRUPT_ERROR    ;rjmp TIM2_OVF   ; Timer2 Overflow Handler
rjmp INTERRUPT_ERROR    ;rjmp TIM1_CAPT  ; Timer1 Capture Handler
rjmp INTERRUPT_ERROR    ;rjmp TIM1_COMPA ; Timer1 CompareA Handler
rjmp INTERRUPT_ERROR    ;rjmp TIM1_COMPB ; Timer1 CompareB Handler
rjmp TIM1_OVF             ; Timer1 Overflow Handler
rjmp TIM0_OVF              ; Timer0 Overflow Handler
rjmp INTERRUPT_ERROR    ;rjmp SPI_STC    ; SPI Transfer Complete Handler
rjmp INTERRUPT_ERROR    ;rjmp ZEICHEN_EINLESEN     ; USART RX Complete Handler
rjmp INTERRUPT_ERROR    ;rjmp USART_UDRE ; UDR Empty Handler
rjmp INTERRUPT_ERROR    ;rjmp USART_TXC  ; USART TX Complete Handler
rjmp INTERRUPT_ERROR    ;rjmp ADC        ; ADC Conversion Complete Handler
rjmp INTERRUPT_ERROR    ;rjmp EE_RDY     ; EEPROM Ready Handler
rjmp INTERRUPT_ERROR    ;rjmp ANA_COMP   ; Analog Comparator Handler
rjmp INTERRUPT_ERROR    ;rjmp TWSI       ; Two-wire Serial Interface Handler
rjmp INTERRUPT_ERROR    ;rjmp SPM_RDY    ; Store Program Memory Ready Handler


; Bei unkorrekten Interrupt aufrufen erfolgt RESET
INTERRUPT_ERROR:
INTERRUPT_ERROR_SCHLEIFE:
    rjmp INTERRUPT_ERROR_SCHLEIFE

RESET:
; STACK initialisieren
    ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp



; SRAM lschen
SRAM_CLEAR:
    ldi ZL, LOW (adr_DATEN)
    ldi ZH, HIGH(adr_DATEN)
    clr temp
SRAM_CLEAR_w:
    ST z+,temp
    cpi ZH, HIGH(RAMEND); Vergleich?
    brlo SRAM_CLEAR_w    ; kleiner => SPRUNG
    cpi ZL, LOW(RAMEND)    ; Vergleich?
    brlo SRAM_CLEAR_w    ; kleiner => SPRUNG
    breq SRAM_CLEAR_w    ; gleich  => SPRUNG


; PORT B initialisieren
    ldi temp, 0b00111111
    out DDRB, temp
; PORT B setzen
    out PORTB, temp
; PORT C initialisieren
    ldi temp, 0b00111111
    out DDRC, temp
; PORT C setzen
    out PORTC, temp
; PORT D initialisieren
    ldi temp, 0b00000000
    out DDRD, temp
; PORT D setzen
    ldi temp, 0b11011111 ; PULL-UPS ein
    out PORTD, temp

; Watchdog aktivieren (max. Zeit)
    ldi TEMP,(1<<WDCE)|(1<<WDE)
    out wdtcr,TEMP
    ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0)
    out wdtcr,temp

;
; SLEEP+INT0+INT1 (externer Interrupt) konfigurieren
;
; MCUCR => SE SM2 SM1 SM0 ISC11 ISC10 ISC01 ISC00
; SM2 SM1 SM0 Sleep Mode
;*0   0   0   Idle
; 0   0   1   ADC Noise Reduction
; 0   1   0   Power-down
; 0   1   1   Power-save
; 1   0   0   Reserved
; 1   0   1   Reserved
; 1   1   0   Standby(1)
;
;ISC11 ISC10 Description
; 0     0     The low level of INT1 generates an interrupt request.
; 0     1     Any logical change on INT1 generates an interrupt request.
; 1     0     The falling edge of INT1 generates an interrupt request.
; 1     1     The rising edge of INT1 generates an interrupt request.
;
;ISC01 ISC00 Description
; 0     0     The low level of INT0 generates an interrupt request.
; 0     1     Any logical change on INT0 generates an interrupt request.
; 1     0     The falling edge of INT0 generates an interrupt request.
; 1     1     The rising  edge of INT0 generates an interrupt request.
;
    ldi temp,(1<<SE)|(0<<SM2)|(0<<SM1)|(0<<SM0)|(0<<ISC11)|(0<<ISC10)|(0<<ISC01)|(0<<ISC00)
    out MCUCR,temp

;
; INT0+INT1 (externer Interrupt)de-aktivieren
;
; GICR => INT1 INT0 - - - - IVSEL IVCE
; General Interrupt Control
;
    ldi temp, (0<<INT1)|(0<<INT0)|(0<<IVSEL)|(0<<IVCE)
    out GICR, temp


; TIMER0_INITIALISIERUNG
    rcall TIMER0_INITIALISIERUNG
; TIMER1_INITIALISIERUNG
    rcall TIMER1_INITIALISIERUNG

;
; Timer 0+1+2 berlauf-Int aktivieren (Timer/Counter Interrupt Mask)
;
; TIMSK ==> OCIE2 TOIE2 TICIE1 OCIE1A OCIE1B TOIE1 R TOIE0
;
    ldi temp,(0<<OCIE2)|(0<<TOIE2)|(0<<TICIE1)|(0<<OCIE1A)|(0<<OCIE1B)|(1<<TOIE1)|(1<<TOIE0)
    out TIMSK,temp


; STARTWERTE
    ; NULL
    clr NULL
    ; EINS
    ldi temp,1
    mov EINS,temp
    ; SIMULATION
    ;STS(adr_SIMULATION_AKTIV),EINS

; interrupts freigeben
    sei

; ##############################################################################
; ##############################################################################
; ##############################################################################

; LED-TEST
    rcall LED_TEST
; RELAIS_TEST
    rcall RELAIS_TEST
; EEPROM_KONFIGURATION_LADEN
    rcall EEPROM_KONFIGURATION_LADEN
; RELAIS setzen
    rcall RELAIS_SETZEN_MODUS
; PROGRAMMSTARTS_ZAEHLEN
    rcall PROGRAMMSTARTS_ZAEHLEN
; LCD_INITIALISIERUNG
    rcall LCD_INITIALISIERUNG
; ANZEIGE_BEGRUESSUNG
    rcall ANZEIGE_BEGRUESSUNG
;     rcall KALIBRIERUNG
    rcall KALIBRIERUNG_START
; ANZEIGE_FREQUENZ_AKTUELL
    rcall ANZEIGE_FREQUENZ_AKTUELL
    rcall wait_1s
    rcall wait_1s
; ANZEIGE_L_C
    rcall ANZEIGE_L_C
    rcall wait_1s
    rcall wait_1s
; ANZEIGE_PROGRAMMSTARTS
    rcall ANZEIGE_PROGRAMMSTARTS
    rcall wait_1s
    rcall wait_1s
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
    WDR                            ; Watch-Dog-RESET

    rcall ABFRAGE_TASTATUR        ; Tastenabfrage

    rcall RELAIS_SETZEN_MODUS    ; Relais setzen

    rcall KALIBRIERUNG            ; Berechnung L und C

    rcall MESSEN                ; Cx und Lx messen

    rcall ANZEIGE_MENUE            ; LCD ANZEIGE

    rcall ANZEIGE_MENUE_EBENE_1    ; LCD ANZEIGE (EDIT / VIEW)

    rcall EEPROM_KONFIGURATION_SPEICHERN    ; EEPROM

    rcall PROGRAMM_CHECK        ; Programm berprfung

    rcall TASTATUR_PAUSE        ; Pause, wenn Taste gedrckt

rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
KALIBRIERUNG:
    ; TASTATUR
    LDS temp,(adr_TASTE)
    ; TASTE KALIBRIERUNG gedrckt ?
    cpi temp,(TASTE_KALIBRIERUNG)
    breq KALIBRIERUNG_START
    ret
;--------------------------------------------------------------------------------
KALIBRIERUNG_START:
    ; f1=LEERLAUF-FREQUENZ speichern (ohne Cx und Cref)
    LDS temp1,(adr_FREQUENZ_MOMENTAN_BYTE_1)
    LDS temp2,(adr_FREQUENZ_MOMENTAN_BYTE_2)
    LDS temp3,(adr_FREQUENZ_MOMENTAN_BYTE_3)
    ; SIMULATION aktiviert ?
    LDS temp,(adr_SIMULATION_AKTIV)
    tst temp
    breq KALIBRIERUNG_NO_S
    ; TESTZAHLEN
    ldi temp1,BYTE1(f1)
    ldi temp2,BYTE2(f1)
    ldi temp3,BYTE3(f1)
KALIBRIERUNG_NO_S:
    ; FEHLERPRFUNG    (bei Frequenz kleiner 1.000 ==> ERROR
    cpi temp3,BYTE3(1000)
    brlo KALIBRIERUNG_ERROR_A
    breq KALIBRIERUNG_P2
    brsh KALIBRIERUNG_KEIN_ERROR
KALIBRIERUNG_P2:
    cpi temp2,BYTE2(1000)
    brlo KALIBRIERUNG_ERROR_A
    breq KALIBRIERUNG_P1
    brsh KALIBRIERUNG_KEIN_ERROR
KALIBRIERUNG_P1:
    cpi temp1,BYTE1(1000)
    brlo KALIBRIERUNG_ERROR_A
    breq KALIBRIERUNG_KEIN_ERROR
    brsh KALIBRIERUNG_KEIN_ERROR
    ; Fehlermeldung
KALIBRIERUNG_ERROR_A:
    rcall ANZEIGE_ERROR_KALIBRIERUNG_A
    rcall wait_1s
    ret
KALIBRIERUNG_KEIN_ERROR:
    ; speichern
    STS(adr_FREQUENZ_F1_BYTE_1),temp1
    STS(adr_FREQUENZ_F1_BYTE_2),temp2
    STS(adr_FREQUENZ_F1_BYTE_3),temp3
    ; Referenz Kondensator zuschalten
    cbi PORTC,RELAIS_C_REF
    rcall ANZEIGE_KALIBRIERUNG
    rcall FREQUENZZAEHLER_CLEAR
    ; 3 s WARTEN
    rcall LCD_PUNKT        ;
    rcall wait_1s
    rcall LCD_PUNKT        ;
    rcall wait_1s
    rcall LCD_PUNKT        ;
    rcall wait_1s
    ; aktuelle Frequenz auslesen
    LDS temp1,(adr_FREQUENZ_MOMENTAN_BYTE_1)
    LDS temp2,(adr_FREQUENZ_MOMENTAN_BYTE_2)
    LDS temp3,(adr_FREQUENZ_MOMENTAN_BYTE_3)
    ; SIMULATION aktiviert ?
    LDS temp,(adr_SIMULATION_AKTIV)
    tst temp
    breq KALIBRIERUNG_NO_S2
    ; TESTZAHLEN
    ldi temp1,BYTE1(f2)
    ldi temp2,BYTE2(f2)
    ldi temp3,BYTE3(f2)
KALIBRIERUNG_NO_S2:
    ; speichern als Kalibrierungsfrequenz(mit Cref)
    STS(adr_FREQUENZ_KALI_BYTE_1),temp1
    STS(adr_FREQUENZ_KALI_BYTE_2),temp2
    STS(adr_FREQUENZ_KALI_BYTE_3),temp3
    ; Referenz Kondensator abschalten
    sbi PORTC,RELAIS_C_REF
    rcall FREQUENZZAEHLER_CLEAR
;--------------------------------------------------------------------------------
    ; FEHLERPRFUNG    (Frequenz f1 muss grer sein als Kalibrierungsfrequenz)
    ; f1 laden (Frequenz ohne Cref)
    LDS temp1,(adr_FREQUENZ_F1_BYTE_1)
    LDS temp2,(adr_FREQUENZ_F1_BYTE_2)
    LDS temp3,(adr_FREQUENZ_F1_BYTE_3)
    ; KALIBRIERUNGSFREQUENZ laden (mit Cref)
    LDS temp4,(adr_FREQUENZ_KALI_BYTE_1)
    LDS temp5,(adr_FREQUENZ_KALI_BYTE_2)
    LDS temp6,(adr_FREQUENZ_KALI_BYTE_3)
    ; VERGLEICH
    cp temp3,temp6
    brlo KALIBRIERUNG_ERROR_FREQENZEN
    breq KALIBRIERUNG_B2
    brsh KALIBRIERUNG_ALLES_OK
KALIBRIERUNG_B2:
    cp temp2,temp5
    brlo KALIBRIERUNG_ERROR_FREQENZEN
    breq KALIBRIERUNG_B1
    brsh KALIBRIERUNG_ALLES_OK
KALIBRIERUNG_B1:
    cp temp1,temp4
    brlo KALIBRIERUNG_ERROR_FREQENZEN
    breq KALIBRIERUNG_ERROR_FREQENZEN
    brsh KALIBRIERUNG_ALLES_OK
    ; ERROR
KALIBRIERUNG_ERROR_FREQENZEN:
    rcall ANZEIGE_ERROR_KALIBRIERUNG_B
    ret
KALIBRIERUNG_ALLES_OK:
;--------------------------------------------------------------------------------
    ; BERECHNUNG C
    ldi temp, 'C'        ;
    rcall LCD_DATA
    rcall BERECHNUNG_C
    ; BERECHNUNG_L
    ldi temp, 'L'        ;
    rcall LCD_DATA
    rcall BERECHNUNG_L
    rcall LCD_PUNKT        ;
    rcall wait_1s
    rcall LCD_PUNKT        ;
    rcall wait_1s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MESSEN:
    ; TASTATUR
    LDS temp,(adr_TASTE)
    ; TASTE KALIBRIERUNG gedrckt ?
    cpi temp,(TASTE_START_MESSUNG)
    breq MESSEN_START
    ret
;--------------------------------------------------------------------------------
MESSEN_START:
    ; TEXT wait
    rcall ANZEIGE_WAIT
    rcall wait_100ms
    rcall wait_100ms
    rcall wait_100ms
    rcall wait_100ms
    rcall wait_100ms
    ; MODUS laden
    LDS temp,(adr_MODUS)
    ; Z-ZEIGER initialisieren
    ldi ZL,low (MESSEN_START_SPRUNG)
    ldi ZH,high(MESSEN_START_SPRUNG)
    add ZL,temp
    adc ZH,NULL
    IJMP        ; SPRUNG nach Z

MESSEN_START_SPRUNG:
    rjmp BERECHNUNG_CX                ; MODUS 0
    rjmp BERECHNUNG_LX_SERIEL        ; MODUS 1
    rjmp BERECHNUNG_LX_PARALLEL        ; MODUS 2
    rjmp BERECHNUNG_LxCx            ; MODUS 3
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
RELAIS_SETZEN_MODUS:
    ; TASTE
    LDS temp,(adr_TASTE)
    ; TASTE MODUS
    cpi temp,(TASTE_MODUS)
    brne RELAIS_SETZEN_MODUS_START
    ; MODUS + 1
    LDS temp,(adr_MODUS)
    inc temp
    STS (adr_MODUS),temp
    ; auf HAUPTMENUE umschalten
    STS (adr_MENUE),NULL
    ; FEHLERPRFUNG
    cpi temp,3+1
    brlo RELAIS_SETZEN_MODUS_START
    STS (adr_MODUS),NULL
RELAIS_SETZEN_MODUS_START:
;
    LDS temp,(adr_MODUS)

    cpi temp,0
    breq RELAIS_SETZEN_MODUS_0

    cpi temp,1
    breq RELAIS_SETZEN_MODUS_1

    cpi temp,2
    breq RELAIS_SETZEN_MODUS_2

    cpi temp,3
    breq RELAIS_SETZEN_MODUS_3

    ret

; Cx messen
RELAIS_SETZEN_MODUS_0:
    cbi PORTC,RELAIS_C            ;*KONDENSATOR
    cbi PORTC,RELAIS_L_GND        ;*Induktivitt gegen GND
    sbi PORTC,RELAIS_L_REIHE    ; Induktivitt Reihe zum Ausgang
    cbi PORTC,RELAIS_DIREKT        ;*Relais zur Ausgangsbuchse
    ; Grn an
    sbi DDRC, LED_C_MODUS
    sbi PORTC,LED_C_MODUS        ; LEDs MODUS
    ret
; Lx SERIE messen
RELAIS_SETZEN_MODUS_1:
    cbi PORTC,RELAIS_C            ;*KONDENSATOR
    sbi PORTC,RELAIS_L_GND        ; Induktivitt gegen GND
    cbi PORTC,RELAIS_L_REIHE    ;*Induktivitt Reihe zum Ausgang
    sbi PORTC,RELAIS_DIREKT        ; Relais zur Ausgangsbuchse
    ; GELB an
    sbi DDRC, LED_C_MODUS
    cbi PORTC,LED_C_MODUS        ; LEDs MODUS
    ret
; Lx parallel messen
RELAIS_SETZEN_MODUS_2:
    cbi PORTC,RELAIS_C            ;*KONDENSATOR
    cbi PORTC,RELAIS_L_GND        ;*Induktivitt gegen GND
    sbi PORTC,RELAIS_L_REIHE    ; Induktivitt Reihe zum Ausgang
    cbi PORTC,RELAIS_DIREKT        ;*Relais zur Ausgangsbuchse
    ; GELB an
    sbi DDRC, LED_C_MODUS
    cbi PORTC,LED_C_MODUS        ; LEDs MODUS
    ret
; Cx + Lx messen
RELAIS_SETZEN_MODUS_3:
    sbi PORTC,RELAIS_C            ; KONDENSATOR
    sbi PORTC,RELAIS_L_GND        ; Induktivitt gegen GND
    sbi PORTC,RELAIS_L_REIHE    ; Induktivitt Reihe zum Ausgang
    cbi PORTC,RELAIS_DIREKT        ;*Relais zur Ausgangsbuchse
    ; GRN+GELB an
    cbi DDRC, LED_C_MODUS
ret

; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "LC_LCD.asm"
.include "LC_LCD_MENUE.asm"
.include "LC_LCD_TEXTE.asm"
.include "LC_TIMER.asm"
.include "LC_FUNKTIONEN.asm"
.include "LC_BERECHNUNGEN.asm"
.include "LC_sonstiges.asm"
; ##############################################################################
; ##############################################################################
; ##############################################################################


TEXT_BEGRUESSUNG_1:
.db "LC-METER",0

TEXT_BEGRUESSUNG_2:
.db "",0

TEXT_BEGRUESSUNG_3:
.db "ATmega 8",0

TEXT_BEGRUESSUNG_4:
.db "16.000.000 Hz",0

TEXT_BEGRUESSUNG_5:
.db "Version 2.1a",0

TEXT_BEGRUESSUNG_6:
.db "18. Januar 2007",0


TEXT_REFERENZ_C:
.db "REFERENZ-C",0

TEXT_EDIT_REFERENZ_C:
.db "EDIT REFERENZ-C",0

TEXT_FREQUENZ_AKTUELL:
.db "FREQUENZ aktuell",0

TEXT_FREQUENZ_KALIBRIERUNG:
.db "FREQUENZ KALIB",0

TEXT_TASTATUR:
.db "TASTATUR",0

TEXT_WAIT:
.db "wait...",0

TEXT_EDIT_VIEW:
.db "EDIT/VIEW...",0

TEXT_SIMULATION:
.db "SIMULATION",0

TEXT_HILFE_1:
.db "TASTE MENUE +/-",0

TEXT_HILFE_2:
.db "druecken",0

TEXT_RESET:
.db "RESET ?",0

TEXT_LEER:
.db "LEER",0

TEXT_KALIBRIERUNG:
.db "KALIBRIERUNG",0

TEXT_MODUS_0:
.db "Kondensator",0

TEXT_MODUS_1:
.db "L Reihe",0

TEXT_MODUS_2:
.db "L parallel",0

TEXT_MODUS_3:
.db "L-C Schwingkreis",0

TEXT_PROGRAMM_STARTS:
.db "PROGRAMM-STARTS",0


TEXT_WERKSEINSTELLUNG:
.db "WERKSEINSTELLUNG",0

TEXT_ERROR:
.db "ERROR",0

TEXT_KEINE_FREQUENZ:
.db "keine FREQUENZ !",0

TEXT_FREQUEMZFEHLER:
.db "FREQUENZFEHLER !",0
