; ##############################################################################
; ##############################################################################
; ##############################################################################
TIMER0_INITIALISIERUNG:
; TIMER0 (8Bit) Vorteiler													
;																			
; CS02 CS01 CS00 	Description												
;	0 	0 	0 		No clock source (Timer/Counter stopped).				
;	0 	0 	1 		clkI/O/		(No prescaling)								
;	0 	1 	0 		clkI/O/8 	(From prescaler)							
; *	0 	1 	1 		clkI/O/64 	(From prescaler)							
; 	1 	0 	0 		clkI/O/256 	(From prescaler)							
; 	1 	0 	1 		clkI/O/1024 (From prescaler)							
;	1 	1 	0 		External clock source on T0 pin. Clock on falling edge.	
;	1 	1 	1 		External clock source on T0 pin. Clock on rising edge.	
	ldi temp,(0<<CS02)|(1<<CS01)|(1<<CS00)
	OUT TCCR0,temp
; TIMER0 Startwert		
	ldi temp, TIMERWERT0
	out TCNT0,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FREQUENZZAEHLER_CLEAR:
	; TIMER0 Startwert		
	ldi temp, TIMERWERT0
	out TCNT0,temp
	; Timer 1 CLEAR			
	out tcnt1H,NULL         
	out tcnt1L,NULL
	; 1000el clear			
	STS (adr_ss1000_L),NULL
	STS (adr_ss1000_H),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TIMER1_INITIALISIERUNG:
;																			
; Timer1 (16Bit ) 			 												
;																			
; TCCR1B ==> ICNC1 ICES1 RESERVIERT WGM13 WGM12 CS12 CS11 CS10 				
;																			
;CS12 CS11 CS10 Description													
;	0	0 	0 	No clock source. (Timer/Counter stopped)					
;	0 	0 	1 	clkI/O/1    (No prescaling)									
;	0 	1 	0 	clkI/O/8    (From prescaler)								
;	0 	1 	1 	clkI/O/64   (From prescaler)								
;	1 	0 	0 	clkI/O/256  (From prescaler)								
; 	1 	0 	1 	clkI/O/1024 (From prescaler)								
; *	1 	1 	0 	External clock source on T1 pin. Clock on falling edge.		
;	1 	1 	1 	External clock source on T1 pin. Clock on rising edge.		
;																			
	ldi temp,(1<<CS12)|(1<<CS11) |(0<<CS10)
	out TCCR1B,temp          
; Timer 1 CLEAR	
	clr temp
	out tcnt1H,temp         
	clr temp
	out tcnt1L,temp     
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 1000-el Timer																	
TIM0_OVF:
	push TEMP		    ; Sichern 			
	push ZL
	push ZH
	in	 TEMP,SREG		
	push TEMP	    	
; ----------------------------------
; TIMER0 Startwert					
	ldi temp, TIMERWERT0
	out TCNT0,temp
; ----------------------------------
	LDS ZL,(adr_ss1000_L)
	LDS ZH,(adr_ss1000_H)
	adiw ZL,1
	STS (adr_ss1000_L),ZL
	STS (adr_ss1000_H),ZH
	; VERGLEICH		
	cpi ZH,high(1000)
	breq TIM0_OVF_w
	brsh TIM0_OVF_ACTION
	brlo TIM0_OVF_FERTIG
TIM0_OVF_w:
	cpi ZL,low(1000)
	brlo TIM0_OVF_FERTIG
TIM0_OVF_ACTION:
	; EINLESEN		
	in ZL,TCNT1L
	in ZH,TCNT1H	
	; Timer 1 CLEAR	
	out tcnt1H,NULL         
	out tcnt1L,NULL
	; SPEICHERN		
	STS (adr_FREQUENZ_MOMENTAN_BYTE_1),ZL
	STS (adr_FREQUENZ_MOMENTAN_BYTE_2),ZH
	LDS temp,(adr_FREQUENZ_UEBERLAUF)
	STS (adr_FREQUENZ_MOMENTAN_BYTE_3),temp
	; berlauf clear
	STS(adr_FREQUENZ_UEBERLAUF),NULL
	; 1000el clear	
	STS (adr_ss1000_L),NULL
	STS (adr_ss1000_H),NULL
TIM0_OVF_FERTIG:
; ----------------------------------
	pop	TEMP			; Wiederherstellen 
	out	SREG,TEMP		
	pop ZH
	pop ZL
	pop	TEMP	
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Frequenzzhler																
TIM1_OVF:
	push TEMP		    ; Sichern 			
	in	 TEMP,SREG		
	push TEMP	    	
; ----------------------------------

	
	; berlauf	
	LDS temp,(adr_FREQUENZ_UEBERLAUF)
	inc temp
	STS (adr_FREQUENZ_UEBERLAUF),temp


; ----------------------------------
	pop	TEMP			; Wiederherstellen 
	out	SREG,TEMP		
	pop	TEMP			
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################

; ##############################################################################
; ##############################################################################
; ##############################################################################