; ##############################################################################
; ##############################################################################
; ##############################################################################
ABFRAGE_TASTATUR:
	in temp,PIND
	; BIT-Muster	
	com temp
	andi temp,0b11011111
	; SPEICHERN		
	STS(adr_TASTE),temp

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTATUR_PAUSE:
	LDS temp,(adr_TASTE)
	tst temp
	breq TASTATUR_PAUSE_w
	rcall wait_100ms
	rcall wait_100ms
	rcall wait_100ms
	rcall wait_100ms
	rcall wait_100ms
TASTATUR_PAUSE_w:
	rcall wait_100ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
NEUSTART_MIT_WDR:
	WDR
	in temp, MCUCSR
	andi temp,0b00001000
	tst temp
	breq NEUSTART_MIT_WDR_FEHLER
	; MCUCSR clear		
	out MCUCSR,NULL
	ret
NEUSTART_MIT_WDR_FEHLER:
	rjmp NEUSTART_MIT_WDR_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	tst NULL
	brne PROGRAMM_CHECK_FEHLER
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_FEHLER
	ret
; SCHLEIFE, bis WDR zubeit		
PROGRAMM_CHECK_FEHLER:
	rjmp PROGRAMM_CHECK_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_TEST:
	; LED GELB an		
	cbi PORTC,LED_C_MODUS		; LEDs MODUS					
	rcall wait_100ms
	; beide LEDs an		
	cbi DDRC,LED_C_MODUS
	rcall wait_100ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
RELAIS_TEST:
	; alles an	
	cbi PORTC,RELAIS_C_REF
	rcall wait_100ms
	cbi PORTC,RELAIS_C
	rcall wait_100ms
	cbi PORTC,RELAIS_L_GND
	rcall wait_100ms
	cbi PORTC,RELAIS_L_REIHE
	rcall wait_100ms
	cbi PORTC,RELAIS_DIREKT
	rcall wait_100ms

	; alles aus	
	sbi PORTC,RELAIS_C_REF		; Referenz Kondensator			
	sbi PORTC,RELAIS_C			; KONDENSATOR					
	sbi PORTC,RELAIS_L_GND		; Induktivitt gegen GND		
	sbi PORTC,RELAIS_L_REIHE	; Induktivitt Reihe zum Ausgang
	sbi PORTC,RELAIS_DIREKT		; Relais zur Ausgangsbuchse		

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EEPROM_KONFIGURATION_LADEN:

	; Z-ZEIGER initialisieren	
	ldi ZL,low (adr_EEPROM_REF_C_BYTE_0)
	ldi ZH,high(adr_EEPROM_REF_C_BYTE_0)
	; aus EEPROM lesen und Z+1	
	rcall EEPROM_READ_PLUS ; INP: ZL+ZH(ADRESSE) OUT: TEMP (DATEN)	
	; speichern					
	STS(adr_REFERENZ_C_BYTE_1),temp
	; aus EEPROM lesen und Z+1	
	rcall EEPROM_READ_PLUS ; INP: ZL+ZH(ADRESSE) OUT: TEMP (DATEN)	
	; speichern					
	STS(adr_REFERENZ_C_BYTE_2),temp

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EEPROM_KONFIGURATION_SPEICHERN:
	LDS temp,(adr_KONFIGURATION_SPEICHERN)
	tst temp
	brne EEPROM_KONFIGURATION_SPEICHERN_w
	ret
EEPROM_KONFIGURATION_SPEICHERN_w:
	; speichern de-aktivieren		
	STS (adr_KONFIGURATION_SPEICHERN),NULL

	; Z-ZEIGER initialisieren	
	ldi ZL,low (adr_EEPROM_REF_C_BYTE_0)
	ldi ZH,high(adr_EEPROM_REF_C_BYTE_0)

	LDS temp,(adr_REFERENZ_C_BYTE_1)
	rcall EEPROM_WRITE_PLUS	; INP: TEMP(DATEN) ZL+ZH(ADRESSE) (Z+1)	
	LDS temp,(adr_REFERENZ_C_BYTE_2)
	rcall EEPROM_WRITE_PLUS	; INP: TEMP(DATEN) ZL+ZH(ADRESSE) (Z+1)	


ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMMSTARTS_ZAEHLEN:

	; Z-ZEIGER initialisieren	
	ldi ZL,low (adr_EEPROM_ANZAHL_STARTS_L)
	ldi ZH,high(adr_EEPROM_ANZAHL_STARTS_L)
	; aus EEPROM lesen und Z+1	
	rcall EEPROM_READ_PLUS ; INP: ZL+ZH(ADRESSE) OUT: TEMP (DATEN)	
	mov temp1,temp
	; aus EEPROM lesen und Z+1	
	rcall EEPROM_READ_PLUS ; INP: ZL+ZH(ADRESSE) OUT: TEMP (DATEN)	
	mov temp2,temp

	; +1						
	add temp1,EINS
	adc temp2,NULL

	; Z-ZEIGER initialisieren	
	ldi ZL,low (adr_EEPROM_ANZAHL_STARTS_L)
	ldi ZH,high(adr_EEPROM_ANZAHL_STARTS_L)

	mov temp,temp1
	rcall EEPROM_WRITE_PLUS	; INP: TEMP(DATEN) ZL+ZH(ADRESSE) (Z+1)	

	mov temp,temp2
	rcall EEPROM_WRITE_PLUS	; INP: TEMP(DATEN) ZL+ZH(ADRESSE) (Z+1)	


ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT:	ZL Adresse (low)										
;			ZH Adresse (High)										
;																	
; OUTPUT: 	TEMP (DATEN)											
;																	
; rcall EEPROM_READ_PLUS ; INP: ZL+ZH(ADRESSE) OUT: TEMP (DATEN)	
;																	
EEPROM_READ_PLUS:
	sbic EECR,EEWE 		; Wait for completion of previous write
	rjmp EEPROM_READ_PLUS
	out  EEARH, ZH		; ADRESSE setzen						
	out  EEARL, ZL
	sbi  EECR,EERE		; Start eeprom read by writing EERE		
	in 	 temp,EEDR		; Read data from data register			
	adiw ZL,1			; ADRESSE +1 							
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT:	ZL Adresse (low)										
;			ZH Adresse (High)										
;																	
; 		 	TEMP  DATEN												
;																	
;	rcall EEPROM_WRITE_PLUS	; INP: TEMP(DATEN) ZL+ZH(ADRESSE) (Z+1)	
;																	
EEPROM_WRITE_PLUS:
	sbic EECR,EEWE		; Wait for completion of previous write
	rjmp EEPROM_WRITE_PLUS
	out  EEARH,ZH		; ADRESSE setzen						
	out  EEARL,ZL
	out  EEDR, temp		; Write data  to data register			
	sbi  EECR, EEMWE	; Write logical one to EEMWE			
	sbi  EECR, EEWE		; Start eeprom write by setting EEWE	
	adiw ZL,1			; ADRESSE +1 							
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;Pause nach jeder bertragung;50us Pause
wait50us:                              
           	ldi  temp, 255
wait50us_: 
			dec  temp
           	brne wait50us_
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;Lngere Pause fr manche Befehle;5ms Pause
wait5ms:                               
	push temp1           ; temp1 auf dem Stack sichern            
	push temp2           ; temp2 auf dem Stack sichern            
;------------
        ldi temp1,110
	   	clr temp2

wait5ms_:
   		wdr				; WATCH-DOG	
		dec  temp2
        brne wait5ms_
        dec  temp1
        brne wait5ms_
;------------
	pop temp2      		; temp2 wiederherstellen                    
	pop temp1      		; temp1 wiederherstellen                    
ret

; ##############################################################################
; ##############################################################################
; ##############################################################################
; bei 16 MHz Takt ca. 0,1s Pause												
WAIT_100ms:
	push temp1          ; temp1 auf dem Stack sichern            
	push temp2          ; temp2 auf dem Stack sichern            
	push temp3          ; temp3 auf dem Stack sichern            

;------------
	ldi	temp3,6			;(6 bei 16MHz)			
	clr temp2
	clr	temp1			
WAIT_100ms_w:	
	wdr
	dec	 temp1
	brne WAIT_100ms_w
	dec	 temp2		
	brne WAIT_100ms_w
	dec	 temp3
	brne WAIT_100ms_w
;------------
	pop temp3      		; temp3 wiederherstellen                    
	pop temp2      		; temp2 wiederherstellen                    
	pop temp1      		; temp1 wiederherstellen                    
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; bei 16 MHz Takt ca.1s Pause													
WAIT_1s:
	push temp1          ; temp1 auf dem Stack sichern            
	push temp2          ; temp2 auf dem Stack sichern            
	push temp3          ; temp3 auf dem Stack sichern            

;------------
	ldi	temp3,60		;(60 bei 16MHz)			
	clr temp2
	clr	temp1			
wait1s_w:	
	wdr
	dec	temp1
	brne	wait1s_w
	dec	temp2		
	brne	wait1s_w
	dec	temp3
	brne	wait1s_w
;------------
	pop temp3      		; temp3 wiederherstellen                    
	pop temp2      		; temp2 wiederherstellen                    
	pop temp1      		; temp1 wiederherstellen                    
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################